local _, addonTable = ...;
local Width,Height  = TabFrame_UI:GetWidth(), TabFrame_UI:GetHeight();
local hang_Height,hang_NUM  = 34, 12;
-- --============带本助手====================
local fakuan_biaoti1 = TablistFrame_3_UI:CreateFontString("fakuan_biaoti1_UI");
fakuan_biaoti1:SetPoint("TOPLEFT",TablistFrame_3_UI,"TOPLEFT",25,-7);
fakuan_biaoti1:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_biaoti1:SetText("\124cffFFFF00收入事件\124r");
local fakuan_biaoti2 = TablistFrame_3_UI:CreateFontString("fakuan_biaoti2_UI");
fakuan_biaoti2:SetPoint("TOPLEFT",TablistFrame_3_UI,"TOPLEFT",320,-7);
fakuan_biaoti2:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_biaoti2:SetText("\124cffFFFF00收入金额/G\124r");
local fakuan_biaoti3 = TablistFrame_3_UI:CreateFontString("fakuan_biaoti3_UI");
fakuan_biaoti3:SetPoint("TOPLEFT",TablistFrame_3_UI,"TOPLEFT",460,-7);
fakuan_biaoti3:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_biaoti3:SetText("\124cffFFFF00欠款/G\124r");
local fakuan_biaoti3 = TablistFrame_3_UI:CreateFontString("fakuan_biaoti3_UI");
fakuan_biaoti3:SetPoint("TOPLEFT",TablistFrame_3_UI,"TOPLEFT",560,-7);
fakuan_biaoti3:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_biaoti3:SetText("\124cffFFFF00出资人\124r");
--出资人提示
local fakuan_biaoti3_tishi = CreateFrame("Frame", "fakuan_biaoti3_tishi_UI", TablistFrame_3_UI);
fakuan_biaoti3_tishi:SetSize(30,30);
fakuan_biaoti3_tishi:SetPoint("LEFT",fakuan_biaoti3,"RIGHT",-6,0);
local fakuan_biaoti3_tishi_Texture = fakuan_biaoti3_tishi:CreateTexture("fakuan_biaoti3_tishi_Texture_UI", "BORDER");
fakuan_biaoti3_tishi_Texture:SetTexture("interface/common/help-i.blp");
fakuan_biaoti3_tishi_Texture:SetAllPoints(fakuan_biaoti3_tishi)
fakuan_biaoti3_tishi:SetScript("OnEnter", function ()
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(fakuan_biaoti3_tishi, "ANCHOR_TOPLEFT",0,0);
	GameTooltip:AddLine("请注意：")
	GameTooltip:AddLine("\124cff00ff00未选择\124cffFFff00出资人\124r\124cff00ff00的条目将不会记入罚款和其他收入！\n点击选择受益人\124r")
	GameTooltip:Show();
end);
fakuan_biaoti3_tishi:SetScript("OnLeave", function ()
	GameTooltip:ClearLines();
	GameTooltip:Hide() 
end);
------------------
local function UpdateFakuan(self)
	for i = 1, hang_NUM do
		_G["fakuan_hang_shiyou_"..i.."_UI"]:SetText();
    	_G["fakuan_hang_shouruG_"..i.."_UI"]:SetText();
    	_G["fakuan_hang_shouruG_E_"..i.."_UI"]:Hide();
    	_G["fakuan_hang_shouruG_B_"..i.."_UI"]:Hide();
    	_G["fakuan_hang_shouruG_Q_"..i.."_UI"]:Hide();
    	_G["fakuan_hang_qiankuanG_"..i.."_UI"]:SetText();
    	_G["fakuan_hang_qiankuanG_E_"..i.."_UI"]:Hide();
    	_G["fakuan_hang_qiankuanG_B_"..i.."_UI"]:Hide();
    	_G["fakuan_hang_qiankuanG_Q_"..i.."_UI"]:Hide();
    	_G["fakuan_hang_chuziren_V_"..i.."_UI"]:SetText();
    	_G["fakuan_hang_chuziren_del_"..i.."_UI"]:Hide();
		_G["fakuan_del_"..i.."_UI"]:Hide();
    end
	if #PIG["RaidRecord"]["fakuan"]>0 then
	    local ItemsNum = #PIG["RaidRecord"]["fakuan"];
	    FauxScrollFrame_Update(self, ItemsNum, hang_NUM, hang_Height);
	    local offset = FauxScrollFrame_GetOffset(self);
	    if ItemsNum<hang_NUM then
	    	New_fakuan_hang_NUM=ItemsNum;
	    else
	    	New_fakuan_hang_NUM=hang_NUM;
	    end
		for i = 1, New_fakuan_hang_NUM do
			local dangqian = i+offset;
			if dangqian==1 then
				_G["fakuan_hang_shiyou_"..i.."_UI"]:SetText(PIG["RaidRecord"]["fakuan"][dangqian][1]);
			elseif dangqian==2 then	
	    		_G["fakuan_hang_shiyou_"..i.."_UI"]:SetText("|cff00FA9A"..PIG["RaidRecord"]["fakuan"][dangqian][1].."|r");
	    	elseif dangqian<6 then
	    		_G["fakuan_hang_shiyou_"..i.."_UI"]:SetText(PIG["RaidRecord"]["fakuan"][dangqian][1]);
	    	elseif dangqian<9 then
	    		_G["fakuan_hang_shiyou_"..i.."_UI"]:SetText("|cff00FA9A"..PIG["RaidRecord"]["fakuan"][dangqian][1].."|r");
	    	else
	    		_G["fakuan_hang_shiyou_"..i.."_UI"]:SetText(PIG["RaidRecord"]["fakuan"][dangqian][1]);
	    	end
	    	_G["fakuan_hang_shouruG_"..i.."_UI"]:SetText(PIG["RaidRecord"]["fakuan"][dangqian][2]);
	    	_G["fakuan_hang_shouruG_B_"..i.."_UI"]:Show();
	    	_G["fakuan_hang_shouruG_B_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_hang_shouruG_E_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_hang_shouruG_Q_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_hang_qiankuanG_"..i.."_UI"]:SetText(PIG["RaidRecord"]["fakuan"][dangqian][3]);
	    	_G["fakuan_hang_qiankuanG_B_"..i.."_UI"]:Show();
	    	_G["fakuan_hang_qiankuanG_B_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_hang_qiankuanG_E_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_hang_qiankuanG_Q_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_hang_chuziren_V_"..i.."_UI"]:SetText(PIG["RaidRecord"]["fakuan"][dangqian][4]);
    		_G["fakuan_hang_chuziren_"..i.."_UI"]:SetID(dangqian);
    		_G["fakuan_hang_chuziren_del_"..i.."_UI"]:Show();
    		_G["fakuan_hang_chuziren_del_"..i.."_UI"]:SetID(dangqian);
	    	_G["fakuan_del_"..i.."_UI"]:SetID(dangqian);
	    	if dangqian>8 then
				_G["fakuan_del_"..i.."_UI"]:Show();
			end
		end
	end
	addonTable.RaidRecord_UpdateG();
end
addonTable.RaidRecord_UpdateFakuan=UpdateFakuan;
--刷新选择框角色
local function Updatefakuanxuanze()
	for p=1,8 do
		for pp=1,5 do
			_G["chuzirenXZP_"..p.."_"..pp]:Hide();
			_G["chuzirenXZP_Name_"..p.."_"..pp]:SetText();
			_G["chuzirenXZP_Name_XS_"..p.."_"..pp]:SetText();
		end
    end
	for p=1,8 do
		if #PIG["RaidRecord"]["Raidinfo"][p]>0 then
			for pp=1,#PIG["RaidRecord"]["Raidinfo"][p] do
			   	if PIG["RaidRecord"]["Raidinfo"][p][pp][4]~=nil then
			   		_G["chuzirenXZP_"..p.."_"..pp]:Show();
					_G["chuzirenXZP_Name_"..p.."_"..pp]:SetText(PIG["RaidRecord"]["Raidinfo"][p][pp][4]);
					local _, _, _, wanjiaName = string.find(PIG["RaidRecord"]["Raidinfo"][p][pp][4], "((.+)-)");
					if wanjiaName then
						_G["chuzirenXZP_Name_XS_"..p.."_"..pp]:SetText(wanjiaName);
					else
						_G["chuzirenXZP_Name_XS_"..p.."_"..pp]:SetText(PIG["RaidRecord"]["Raidinfo"][p][pp][4]);
					end
					_G["chuzirenXZP_Name_XS_"..p.."_"..pp]:SetTextColor(PIG["RaidRecord"]["Raidinfo"][p][pp][2][1],PIG["RaidRecord"]["Raidinfo"][p][pp][2][2],PIG["RaidRecord"]["Raidinfo"][p][pp][2][3], 1);
			   	end
			end
		end
	end
end
addonTable.RaidRecord_Updatefakuanxuanze = Updatefakuanxuanze;
--
TablistFrame_3_UI:SetScript("OnShow", function ()
	UpdateFakuan(fakuan_Scroll_UI)
end)
--创建可滚动区域
local fakuan_Scroll = CreateFrame("ScrollFrame","fakuan_Scroll_UI",TablistFrame_3_UI, "FauxScrollFrameTemplate");  
fakuan_Scroll:SetPoint("TOPLEFT",TablistFrame_3_UI,"TOPLEFT",5,-hang_Height+6);
fakuan_Scroll:SetPoint("BOTTOMRIGHT",TablistFrame_3_UI,"BOTTOMRIGHT",-27,5);
fakuan_Scroll:SetScript("OnVerticalScroll", function(self, offset)
    FauxScrollFrame_OnVerticalScroll(self, offset, hang_Height, UpdateFakuan)
end)
for id = 1, hang_NUM do
	local fakuan_hang= CreateFrame("Frame", "fakuan_hang_"..id.."_UI", fakuan_Scroll:GetParent());
	fakuan_hang:SetSize(Width-30, hang_Height);
	if id==1 then
		fakuan_hang:SetPoint("TOP",fakuan_Scroll,"TOP",0,0);
	else
		fakuan_hang:SetPoint("TOP",_G["fakuan_hang_"..(id-1).."_UI"],"BOTTOM",0,-0);
	end
	local fakuan_hang_line = fakuan_hang:CreateLine()
	fakuan_hang_line:SetColorTexture(1,1,1,0.2)
	fakuan_hang_line:SetThickness(1);
	fakuan_hang_line:SetStartPoint("TOPLEFT",0,0.2)
	fakuan_hang_line:SetEndPoint("TOPRIGHT",0,0.2)
	-----
	local fakuan_hang_shiyou = fakuan_hang:CreateFontString("fakuan_hang_shiyou_"..id.."_UI");
	fakuan_hang_shiyou:SetPoint("LEFT",fakuan_hang,"LEFT",18,0);
	fakuan_hang_shiyou:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
	fakuan_hang_shiyou:SetText();
	---------
	local fakuan_hang_shouru = CreateFrame("Frame", "fakuan_hang_shouru_"..id.."_UI", fakuan_hang);
	fakuan_hang_shouru:SetSize(70, hang_Height);
	fakuan_hang_shouru:SetPoint("LEFT", fakuan_hang, "LEFT", 306,0);
	local fakuan_hang_shouruG = fakuan_hang_shouru:CreateFontString("fakuan_hang_shouruG_"..id.."_UI");
	fakuan_hang_shouruG:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
	fakuan_hang_shouruG:SetPoint("RIGHT", fakuan_hang_shouru, "RIGHT", 0,0);
	fakuan_hang_shouruG:SetTextColor(0, 1, 1, 1);
	local fakuan_hang_shouruG_E = CreateFrame('EditBox', 'fakuan_hang_shouruG_E_'..id..'_UI', fakuan_hang_shouru, "BackdropTemplate");
	fakuan_hang_shouruG_E:SetSize(60,hang_Height);
	fakuan_hang_shouruG_E:SetBackdrop({ bgFile = "interface/common/common-input-border.blp",insets = {left = -6,right = 0,top = 2,bottom = -13}})
	fakuan_hang_shouruG_E:SetPoint("RIGHT",fakuan_hang_shouru,"RIGHT",0,0);
	fakuan_hang_shouruG_E:SetFontObject(ChatFontNormal);
	fakuan_hang_shouruG_E:SetMaxLetters(7)
	_G['fakuan_hang_shouruG_E_'..id..'_UI']:SetScript("OnEscapePressed", function(self) 
		self:ClearFocus() 
	end);
	_G['fakuan_hang_shouruG_E_'..id..'_UI']:SetScript("OnEnterPressed", function(self) 
		_G['fakuan_hang_shouruG_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_B_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_E_'..id..'_UI']:Hide();
		_G['fakuan_hang_shouruG_Q_'..id..'_UI']:Hide();
 		local NWEdanjiaV=_G['fakuan_hang_shouruG_E_'..id..'_UI']:GetNumber();
 		_G['fakuan_hang_shouruG_'..id..'_UI']:SetText(NWEdanjiaV);
		PIG["RaidRecord"]["fakuan"][self:GetID()][2]=NWEdanjiaV;
		UpdateFakuan(fakuan_Scroll_UI)
	end);
	_G['fakuan_hang_shouruG_E_'..id..'_UI']:SetScript("OnEditFocusLost", function()
		_G['fakuan_hang_shouruG_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_B_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_E_'..id..'_UI']:Hide();
		_G['fakuan_hang_shouruG_Q_'..id..'_UI']:Hide()
	end);
	local fakuan_hang_shouruG_B = CreateFrame("Button","fakuan_hang_shouruG_B_"..id.."_UI",fakuan_hang_shouru, "TruncatedButtonTemplate");
	fakuan_hang_shouruG_B:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	fakuan_hang_shouruG_B:SetSize(hang_Height-8,hang_Height-8);
	fakuan_hang_shouruG_B:SetPoint("LEFT", fakuan_hang_shouru, "RIGHT", -2,0);
	local fakuan_hang_shouruG_Texture = fakuan_hang_shouruG_B:CreateTexture(nil, "BORDER");
	fakuan_hang_shouruG_Texture:SetTexture("interface/buttons/ui-guildbutton-officernote-up.blp");
	fakuan_hang_shouruG_Texture:SetPoint("CENTER");
	fakuan_hang_shouruG_Texture:SetSize(hang_Height-16,hang_Height-14);
	_G['fakuan_hang_shouruG_B_'..id..'_UI']:SetScript("OnMouseDown", function ()
		fakuan_hang_shouruG_Texture:SetPoint("CENTER",-1.5,-1.5);
	end);
	_G['fakuan_hang_shouruG_B_'..id..'_UI']:SetScript("OnMouseUp", function ()
		fakuan_hang_shouruG_Texture:SetPoint("CENTER");
	end);
	_G['fakuan_hang_shouruG_B_'..id..'_UI']:SetScript("OnClick", function (self)
		for xx=1,hang_NUM do
			_G['fakuan_hang_shouruG_E_'..xx..'_UI']:ClearFocus() 
			_G['fakuan_hang_qiankuanG_E_'..xx..'_UI']:ClearFocus() 
		end
		_G['fakuan_hang_shouruG_'..id..'_UI']:Hide();
		_G['fakuan_hang_shouruG_B_'..id..'_UI']:Hide();
		_G['fakuan_hang_shouruG_E_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_Q_'..id..'_UI']:Show();
 		_G['fakuan_hang_shouruG_E_'..id..'_UI']:SetText(PIG["RaidRecord"]["fakuan"][self:GetID()][2]);
	end);
	local fakuan_hang_shouruG_Q = CreateFrame("Button","fakuan_hang_shouruG_Q_"..id.."_UI",fakuan_hang_shouru, "UIPanelButtonTemplate");
	fakuan_hang_shouruG_Q:SetSize(hang_Height,hang_Height-10);
	fakuan_hang_shouruG_Q:SetPoint("LEFT", fakuan_hang_shouru, "RIGHT", 2,0);
	fakuan_hang_shouruG_Q:Hide();
	fakuan_hang_shouruG_Q:SetText('确定');
	buttonFont=fakuan_hang_shouruG_Q:GetFontString()
	buttonFont:SetFont(ChatFontNormal:GetFont(), 12);
	_G['fakuan_hang_shouruG_Q_'..id..'_UI']:SetScript("OnClick", function (self)
		_G['fakuan_hang_shouruG_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_B_'..id..'_UI']:Show();
		_G['fakuan_hang_shouruG_E_'..id..'_UI']:Hide();
		_G['fakuan_hang_shouruG_Q_'..id..'_UI']:Hide();
 		local NWEdanjiaV=_G['fakuan_hang_shouruG_E_'..id..'_UI']:GetNumber();
 		_G['fakuan_hang_shouruG_'..id..'_UI']:SetText(NWEdanjiaV);
		PIG["RaidRecord"]["fakuan"][self:GetID()][2]=NWEdanjiaV;
		UpdateFakuan(fakuan_Scroll_UI)
	end);
	-----欠款-----
	local fakuan_hang_qiankuan = CreateFrame("Frame", "fakuan_hang_qiankuan_"..id.."_UI", fakuan_hang);
	fakuan_hang_qiankuan:SetSize(70, hang_Height);
	fakuan_hang_qiankuan:SetPoint("LEFT", fakuan_hang, "LEFT", 420,0);
	local fakuan_hang_qiankuanG = fakuan_hang_qiankuan:CreateFontString("fakuan_hang_qiankuanG_"..id.."_UI");
	fakuan_hang_qiankuanG:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
	fakuan_hang_qiankuanG:SetPoint("RIGHT", fakuan_hang_qiankuan, "RIGHT", 0,0);
	fakuan_hang_qiankuanG:SetTextColor(252/255, 69/255, 0/255, 1);
	local fakuan_hang_qiankuanG_E = CreateFrame('EditBox', 'fakuan_hang_qiankuanG_E_'..id..'_UI', fakuan_hang_qiankuan, "BackdropTemplate");
	fakuan_hang_qiankuanG_E:SetSize(60,hang_Height);
	fakuan_hang_qiankuanG_E:SetBackdrop({ bgFile = "interface/common/common-input-border.blp",insets = {left = -6,right = 0,top = 2,bottom = -13}})
	fakuan_hang_qiankuanG_E:SetPoint("RIGHT",fakuan_hang_qiankuan,"RIGHT",0,0);
	fakuan_hang_qiankuanG_E:SetFontObject(ChatFontNormal);
	fakuan_hang_qiankuanG_E:SetMaxLetters(7)
	_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:SetScript("OnEscapePressed", function(self) 
		self:ClearFocus() 
	end);
	_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:SetScript("OnEnterPressed", function(self) 
		_G['fakuan_hang_qiankuanG_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:Hide();
		_G['fakuan_hang_qiankuanG_Q_'..id..'_UI']:Hide();
 		local xinqiankuanG=_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:GetNumber();
		--增减罚款
		-- if PIG["RaidRecord"]["fakuan"][self:GetID()][2]>0 and PIG["RaidRecord"]["fakuan"][self:GetID()][3]>0 then
		-- 	local qiankuanguihaiG=PIG["RaidRecord"]["fakuan"][self:GetID()][3]-xinqiankuanG;
		-- 	PIG["RaidRecord"]["fakuan"][self:GetID()][2]=PIG["RaidRecord"]["fakuan"][self:GetID()][2]+qiankuanguihaiG;
		-- 	_G['fakuan_hang_shouruG_'..id..'_UI']:SetText(PIG["RaidRecord"]["fakuan"][self:GetID()][2]);
		-- end
		--
		_G['fakuan_hang_qiankuanG_'..id..'_UI']:SetText(xinqiankuanG);
		PIG["RaidRecord"]["fakuan"][self:GetID()][3]=xinqiankuanG;
		UpdateFakuan(fakuan_Scroll_UI)
	end);
	_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:SetScript("OnEditFocusLost", function()
		_G['fakuan_hang_qiankuanG_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:Hide();
		_G['fakuan_hang_qiankuanG_Q_'..id..'_UI']:Hide()
	end);
	local fakuan_hang_qiankuanG_B = CreateFrame("Button","fakuan_hang_qiankuanG_B_"..id.."_UI",fakuan_hang_qiankuan, "TruncatedButtonTemplate");
	fakuan_hang_qiankuanG_B:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	fakuan_hang_qiankuanG_B:SetSize(hang_Height-8,hang_Height-8);
	fakuan_hang_qiankuanG_B:SetPoint("LEFT", fakuan_hang_qiankuan, "RIGHT", -2,0);
	local fakuan_hang_qiankuanG_Texture = fakuan_hang_qiankuanG_B:CreateTexture(nil, "BORDER");
	fakuan_hang_qiankuanG_Texture:SetTexture("interface/buttons/ui-guildbutton-officernote-up.blp");
	fakuan_hang_qiankuanG_Texture:SetPoint("CENTER");
	fakuan_hang_qiankuanG_Texture:SetSize(hang_Height-16,hang_Height-14);
	_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:SetScript("OnMouseDown", function ()
		fakuan_hang_qiankuanG_Texture:SetPoint("CENTER",-1.5,-1.5);
	end);
	_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:SetScript("OnMouseUp", function ()
		fakuan_hang_qiankuanG_Texture:SetPoint("CENTER");
	end);
	_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:SetScript("OnClick", function (self)
		for xx=1,hang_NUM do
			_G['fakuan_hang_shouruG_E_'..xx..'_UI']:ClearFocus() 
			_G['fakuan_hang_qiankuanG_E_'..xx..'_UI']:ClearFocus() 
		end
		_G['fakuan_hang_qiankuanG_'..id..'_UI']:Hide();
		_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:Hide();
		_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_Q_'..id..'_UI']:Show();
 		_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:SetText(PIG["RaidRecord"]["fakuan"][self:GetID()][3]);
	end);
	local fakuan_hang_qiankuanG_Q = CreateFrame("Button","fakuan_hang_qiankuanG_Q_"..id.."_UI",fakuan_hang_qiankuan, "UIPanelButtonTemplate");
	fakuan_hang_qiankuanG_Q:SetSize(hang_Height,hang_Height-10);
	fakuan_hang_qiankuanG_Q:SetPoint("LEFT", fakuan_hang_qiankuan, "RIGHT", 2,0);
	fakuan_hang_qiankuanG_Q:Hide();
	fakuan_hang_qiankuanG_Q:SetText('确定');
	buttonFont=fakuan_hang_qiankuanG_Q:GetFontString()
	buttonFont:SetFont(ChatFontNormal:GetFont(), 12);
	_G['fakuan_hang_qiankuanG_Q_'..id..'_UI']:SetScript("OnClick", function (self)
		_G['fakuan_hang_qiankuanG_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_B_'..id..'_UI']:Show();
		_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:Hide();
		_G['fakuan_hang_qiankuanG_Q_'..id..'_UI']:Hide();
 		local xinqiankuanG=_G['fakuan_hang_qiankuanG_E_'..id..'_UI']:GetNumber();
		--增减罚款
		-- if PIG["RaidRecord"]["fakuan"][self:GetID()][2]>0 and PIG["RaidRecord"]["fakuan"][self:GetID()][3]>0 then
		-- 	local qiankuanguihaiG=PIG["RaidRecord"]["fakuan"][self:GetID()][3]-xinqiankuanG;
		-- 	PIG["RaidRecord"]["fakuan"][self:GetID()][2]=PIG["RaidRecord"]["fakuan"][self:GetID()][2]+qiankuanguihaiG;
		-- 	_G['fakuan_hang_shouruG_'..id..'_UI']:SetText(PIG["RaidRecord"]["fakuan"][self:GetID()][2]);
		-- end
		--
		_G['fakuan_hang_qiankuanG_'..id..'_UI']:SetText(xinqiankuanG);
		PIG["RaidRecord"]["fakuan"][self:GetID()][3]=xinqiankuanG;
		UpdateFakuan(fakuan_Scroll_UI)
	end);

	-- local fakuan_hang_chuziren = fakuan_hang:CreateFontString("fakuan_hang_chuziren_"..id.."_UI");
	-- fakuan_hang_chuziren:SetPoint("LEFT",fakuan_hang,"LEFT",560,0);
	-- fakuan_hang_chuziren:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
	-- fakuan_hang_chuziren:SetText();
	local fakuan_hang_chuziren = CreateFrame("Button","fakuan_hang_chuziren_"..id.."_UI",fakuan_hang, "TruncatedButtonTemplate");  
	fakuan_hang_chuziren:SetNormalTexture("")
	fakuan_hang_chuziren:SetSize(140, hang_Height-10);
	fakuan_hang_chuziren:SetPoint("LEFT",fakuan_hang,"LEFT",558,0);
	local fakuan_hang_chuziren_V = fakuan_hang_chuziren:CreateFontString("fakuan_hang_chuziren_V_"..id.."_UI");
	fakuan_hang_chuziren_V:SetPoint("LEFT",fakuan_hang_chuziren,"LEFT",0,0);
	fakuan_hang_chuziren_V:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
	_G['fakuan_hang_chuziren_'..id..'_UI']:SetScript("OnMouseDown", function (self)
		_G["fakuan_hang_chuziren_V_"..id.."_UI"]:SetPoint("LEFT",self,"LEFT",1,-1);
	end);
	_G['fakuan_hang_chuziren_'..id..'_UI']:SetScript("OnMouseUp", function (self)
		_G["fakuan_hang_chuziren_V_"..id.."_UI"]:SetPoint("LEFT",self,"LEFT",0,0);
	end);
	_G['fakuan_hang_chuziren_'..id..'_UI']:SetScript("OnClick", function (self)
		if xuanzechuziren_UI:IsShown() then
			xuanzechuziren_UI:Hide();
		else
			xuanzechuziren_UI:Show();
			xuanzechuziren_T2:SetText(PIG["RaidRecord"]["fakuan"][self:GetID()][1])
			xuanzechuziren_T4:SetText(self:GetID())
			Updatefakuanxuanze();
		end
	end);
	local fakuan_hang_chuziren_del = CreateFrame("Button","fakuan_hang_chuziren_del_"..id.."_UI",fakuan_hang, "UIMenuButtonStretchTemplate");
	fakuan_hang_chuziren_del:SetSize(24,24);
	fakuan_hang_chuziren_del:SetPoint("RIGHT", fakuan_hang_chuziren, "LEFT", -2,0);
	local fakuan_hang_chuziren_Tex = fakuan_hang_chuziren_del:CreateTexture(nil, "BORDER");
	fakuan_hang_chuziren_Tex:SetTexture("interface/glues/characterselect/restorebutton.blp");
	fakuan_hang_chuziren_Tex:SetPoint("CENTER");
	fakuan_hang_chuziren_Tex:SetSize(24,24);
	fakuan_hang_chuziren_del:SetScript("OnMouseDown", function ()
		fakuan_hang_chuziren_Tex:SetPoint("CENTER",-1.4,-1.5);
	end);
	fakuan_hang_chuziren_del:SetScript("OnMouseUp", function ()
		fakuan_hang_chuziren_Tex:SetPoint("CENTER");
	end);
	fakuan_hang_chuziren_del:SetScript("OnClick", function (self)
		PIG["RaidRecord"]["fakuan"][self:GetID()][4]="无";
		UpdateFakuan(fakuan_Scroll_UI)
	end);

	local fakuan_del = CreateFrame("Button","fakuan_del_"..id.."_UI",fakuan_hang, "TruncatedButtonTemplate");
	fakuan_del:SetSize(25,25);
	fakuan_del:SetPoint("RIGHT", fakuan_hang, "RIGHT", -4,0);
	local fakuan_del_Texture = fakuan_del:CreateTexture(nil, "BORDER");
	fakuan_del_Texture:SetTexture("interface/common/voicechat-muted.blp");
	fakuan_del_Texture:SetPoint("CENTER");
	fakuan_del_Texture:SetSize(15,15);
	fakuan_del:SetScript("OnMouseDown", function ()
		fakuan_del_Texture:SetPoint("CENTER",-1.5,-1.5);
	end);
	fakuan_del:SetScript("OnMouseUp", function ()
		fakuan_del_Texture:SetPoint("CENTER");
	end);
	fakuan_del:SetScript("OnClick", function (self)
		table.remove(PIG["RaidRecord"]["fakuan"],self:GetID());
		UpdateFakuan(fakuan_Scroll_UI)
	end);
end
-----添加其他收入项目-----
local fakuan_Add = CreateFrame("Button","fakuan_Add_UI",TablistFrame_3_UI, "UIPanelButtonTemplate");
fakuan_Add:SetSize(30,20);
fakuan_Add:SetPoint("LEFT",fakuan_biaoti1,"RIGHT",0,0);
fakuan_Add:SetText("+");
fakuan_Add:SetScript("OnClick", function ()
	if fakuan_add_F_UI:IsShown() then
		fakuan_add_F_UI:Hide();
	else
		fakuan_add_F_UI:Show();
	end
end);

local fakuan_add_F = CreateFrame("Frame", "fakuan_add_F_UI", fakuan_Add_UI);
fakuan_add_F:SetSize(Width,Height-30);
fakuan_add_F:SetPoint("TOP",TablistFrame_3_UI,"TOP",0,-30);
fakuan_add_F:SetFrameLevel(10);
fakuan_add_F:EnableMouse(true);
tinsert(UISpecialFrames,"fakuan_add_F_UI");
local fakuan_add_F_F = CreateFrame("Frame", "fakuan_add_F_F_UI", fakuan_add_F,"BackdropTemplate");
fakuan_add_F_F:SetBackdrop({bgFile = "interface/characterframe/ui-party-background.blp", 
	edgeFile = "interface/glues/common/textpanel-border.blp", 
	tile = true, tileSize = 0, edgeSize = 32,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
fakuan_add_F_F:SetSize(400,180);
fakuan_add_F_F:SetPoint("TOP",fakuan_add_F,"TOP",0,0);
local fakuan_add_F_F_Close = CreateFrame("Button","fakuan_add_F_F_Close_UI",fakuan_add_F, "UIPanelCloseButton");  
fakuan_add_F_F_Close:SetSize(34,34);
fakuan_add_F_F_Close:SetPoint("TOPRIGHT",fakuan_add_F_F,"TOPRIGHT",2.4,3);
local fakuan_add_F_F_biaoti = fakuan_add_F_F:CreateFontString("fakuan_add_F_F_biaoti_UI");
fakuan_add_F_F_biaoti:SetPoint("TOP",fakuan_add_F_F,"TOP",0,-6);
fakuan_add_F_F_biaoti:SetFont(GameFontNormal:GetFont(), 18, "OUTLINE");
fakuan_add_F_F_biaoti:SetTextColor(1,215/255,0, 1);
fakuan_add_F_F_biaoti:SetText("添加收入事件");
--
local fakuan_add_F_F_biaoti1 = fakuan_add_F_F:CreateFontString("fakuan_add_F_F_biaoti1_UI");
fakuan_add_F_F_biaoti1:SetPoint("TOPLEFT",fakuan_add_F_F,"TOPLEFT",30,-40);
fakuan_add_F_F_biaoti1:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_add_F_F_biaoti1:SetText("\124cff00FF00收入事件\124r");
local fakuan_add_F_F_shiyou = CreateFrame('EditBox', 'fakuan_add_F_F_shiyou_UI', fakuan_add_F_F, "BackdropTemplate");
fakuan_add_F_F_shiyou:SetSize(200,34);
fakuan_add_F_F_shiyou:SetBackdrop({ bgFile = "interface/common/common-input-border.blp",insets = {left = -6,right = 0,top = 2,bottom = -13}})
fakuan_add_F_F_shiyou:SetPoint("TOPLEFT",fakuan_add_F_F_biaoti1,"BOTTOMLEFT",0,-10);
fakuan_add_F_F_shiyou:SetFontObject(ChatFontNormal);
fakuan_add_F_F_shiyou:SetMaxLetters(30)
fakuan_add_F_F_shiyou:SetAutoFocus(false);
fakuan_add_F_F_shiyou:SetScript("OnEscapePressed", function(self) 
	self:ClearFocus() 
end);
local fakuan_add_F_F_biaoti2 = fakuan_add_F_F:CreateFontString("fakuan_add_F_F_biaoti2_UI");
fakuan_add_F_F_biaoti2:SetPoint("TOPLEFT",fakuan_add_F_F,"TOPLEFT",260,-40);
fakuan_add_F_F_biaoti2:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_add_F_F_biaoti2:SetText("\124cff00FF00收入金额/G\124r");
local fakuan_add_F_F_G = CreateFrame('EditBox', 'fakuan_add_F_F_G_UI', fakuan_add_F_F, "BackdropTemplate");
fakuan_add_F_F_G:SetSize(80,34);
fakuan_add_F_F_G:SetBackdrop({ bgFile = "interface/common/common-input-border.blp",insets = {left = -6,right = 0,top = 2,bottom = -13}})
fakuan_add_F_F_G:SetPoint("TOPLEFT",fakuan_add_F_F_biaoti2,"BOTTOMLEFT",4,-10);
fakuan_add_F_F_G:SetFontObject(ChatFontNormal);
fakuan_add_F_F_G:SetMaxLetters(9)
fakuan_add_F_F_G:SetAutoFocus(false);
fakuan_add_F_F_G:SetScript("OnEscapePressed", function(self) 
	self:ClearFocus() 
end);
local fakuan_add_F_F_err = fakuan_add_F_F:CreateFontString("fakuan_add_F_F_err_UI");
fakuan_add_F_F_err:SetPoint("TOP",fakuan_add_F_F,"TOP",0,-106);
fakuan_add_F_F_err:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
fakuan_add_F_F_err:SetText();
local fakuan_add_F_F_YES = CreateFrame("Button","fakuan_add_F_F_YES_UI",fakuan_add_F_F, "UIPanelButtonTemplate"); 
fakuan_add_F_F_YES:SetSize(80,28);
fakuan_add_F_F_YES:SetPoint("TOP",fakuan_add_F_F,"TOP",-60,-130);
fakuan_add_F_F_YES:SetText("添加");
fakuan_add_F_F_YES:SetScript("OnClick", function ()
	local qitashouruxiangmu=fakuan_add_F_F_shiyou_UI:GetText();
	local qitashouruG=fakuan_add_F_F_G_UI:GetNumber();
	local x, xx, xxx, xxxx = string.find(qitashouruxiangmu, "(%S+(.+)%S+)");
	--print(x)print(xx)print(xxx)
	if x==nil then
		fakuan_add_F_F_err:SetText("\124cffffff00添加失败：事件不能为空或过短！\124r");	
	else
		for i=1,#PIG["RaidRecord"]["fakuan"] do
			if xxx==PIG["RaidRecord"]["fakuan"][i][1] then
				fakuan_add_F_F_err:SetText("\124cffffff00添加失败：已存在同名事件！\124r");
				return
			end
		end
		local qitashouruinfo={xxx,qitashouruG,0,"无"};
		table.insert(PIG["RaidRecord"]["fakuan"],qitashouruinfo);
		fakuan_add_F_UI:Hide();
		UpdateFakuan(fakuan_Scroll_UI)
	end
end);
local fakuan_add_F_F_NO = CreateFrame("Button","fakuan_add_F_F_NO_UI",fakuan_add_F_F, "UIPanelButtonTemplate");  
fakuan_add_F_F_NO:SetSize(80,28);
fakuan_add_F_F_NO:SetPoint("TOP",fakuan_add_F_F,"TOP",60,-134);
fakuan_add_F_F_NO:SetText("取消");
fakuan_add_F_F_NO:SetScript("OnClick", function ()
	fakuan_add_F_UI:Hide();
end);
fakuan_add_F_UI:SetScript("OnHide", function ()
	fakuan_add_F_F_err_UI:SetText()
end)
---=======================================================
--选择受益人
local xuanzechuziren = CreateFrame("Frame", "xuanzechuziren_UI", TablistFrame_3_UI,"BackdropTemplate");
xuanzechuziren:SetBackdrop( { bgFile = "interface/raidframe/ui-raidframe-groupbg.blp",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, tileSize = 0, edgeSize = 10, 
	insets = { left = 0, right = 0, top = 0, bottom = 0 } });
xuanzechuziren:SetSize(Width-228,Height-12);
xuanzechuziren:SetPoint("TOPRIGHT",fakuan_hang_chuziren_1_UI,"TOPLEFT",-2,28);
xuanzechuziren:SetFrameLevel(10)
xuanzechuziren:EnableMouse(true)
xuanzechuziren:Hide()
local xuanzechuziren_Close = CreateFrame("Button","xuanzechuziren_Close_UI",xuanzechuziren, "UIPanelCloseButton");  
xuanzechuziren_Close:SetSize(30,30);
xuanzechuziren_Close:SetPoint("TOPRIGHT",xuanzechuziren,"TOPRIGHT",2.4,3);
local xuanzechuziren_T1 = xuanzechuziren:CreateFontString("xuanzechuziren_T1");
xuanzechuziren_T1:SetPoint("TOPLEFT",xuanzechuziren,"TOPLEFT",30,-8);
xuanzechuziren_T1:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
xuanzechuziren_T1:SetText("\124cff00ff00选择【\124r")
local xuanzechuziren_T2 = xuanzechuziren:CreateFontString("xuanzechuziren_T2");
xuanzechuziren_T2:SetPoint("LEFT",xuanzechuziren_T1,"RIGHT",0,0);
xuanzechuziren_T2:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
xuanzechuziren_T2:SetText()
local xuanzechuziren_T3 = xuanzechuziren:CreateFontString("xuanzechuziren_T3");
xuanzechuziren_T3:SetPoint("LEFT",xuanzechuziren_T2,"RIGHT",0,0);
xuanzechuziren_T3:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
xuanzechuziren_T3:SetText("\124cff00ff00】出资人\124r")
local xuanzechuziren_T4 = xuanzechuziren:CreateFontString("xuanzechuziren_T4");
xuanzechuziren_T4:SetPoint("LEFT",xuanzechuziren_T3,"RIGHT",0,0);
xuanzechuziren_T4:SetFont(ChatFontNormal:GetFont(), 1, "OUTLINE");
xuanzechuziren_T4:SetText()
xuanzechuziren_T4:Hide()
--
local duiwuW,duiwuH = 120,30;
local jiangeW,jiangeH,juesejiangeH = 12,0,6;
for p=1,8 do
	local chuzirenXZ = CreateFrame("Frame", "chuzirenXZ_"..p.."_UI", xuanzechuziren);
	chuzirenXZ:SetSize(duiwuW,duiwuH*5+juesejiangeH*4);
	if p==1 then
		chuzirenXZ:SetPoint("TOPLEFT",xuanzechuziren,"TOPLEFT",16,-34);
	end
	if p>1 and p<5 then
		chuzirenXZ:SetPoint("LEFT",_G["chuzirenXZ_"..(p-1).."_UI"],"RIGHT",jiangeW,jiangeH);
	end
	if p==5 then
		chuzirenXZ:SetPoint("TOP",_G["chuzirenXZ_1_UI"],"BOTTOM",0,-26);
	end
	if p>5 then
		chuzirenXZ:SetPoint("LEFT",_G["chuzirenXZ_"..(p-1).."_UI"],"RIGHT",jiangeW,jiangeH);
	end
	for pp=1,5 do
		local chuzirenXZP = CreateFrame("Frame", "chuzirenXZP_"..p.."_"..pp, _G["chuzirenXZ_"..p.."_UI"],"BackdropTemplate");
		chuzirenXZP:SetBackdrop( { edgeFile = "Interface/Tooltips/UI-Tooltip-Border",edgeSize = 10, insets = { left = 0, right = 0, top = 0, bottom = 0 } });
		chuzirenXZP:SetBackdropBorderColor(0.5, 0.5, 0.5, 1);
		chuzirenXZP:SetSize(duiwuW,duiwuH);
		if pp==1 then
			chuzirenXZP:SetPoint("TOP",_G["chuzirenXZ_"..p.."_UI"],"TOP",0,0);
		else
			chuzirenXZP:SetPoint("TOP",_G["chuzirenXZP_"..p.."_"..(pp-1)],"BOTTOM",0,-juesejiangeH);
		end
		local chuzirenXZP_highlight = chuzirenXZP:CreateTexture("chuzirenXZP_highlight_"..p.."_"..pp, "BORDER");
		chuzirenXZP_highlight:SetTexture("interface/paperdollinfoframe/ui-character-tab-highlight.blp");
		chuzirenXZP_highlight:SetBlendMode("ADD")
		chuzirenXZP_highlight:SetPoint("CENTER", chuzirenXZP, "CENTER", 0,0);
		chuzirenXZP_highlight:SetSize(duiwuW,duiwuH);
		chuzirenXZP_highlight:Hide();
		_G["chuzirenXZP_"..p.."_"..pp]:SetScript("OnEnter", function (self)
			_G["chuzirenXZP_highlight_"..p.."_"..pp]:Show();
		end);
		_G["chuzirenXZP_"..p.."_"..pp]:SetScript("OnLeave", function (self)
			_G["chuzirenXZP_highlight_"..p.."_"..pp]:Hide();
		end);
		local chuzirenXZP_Name = chuzirenXZP:CreateFontString("chuzirenXZP_Name_"..p.."_"..pp);
		chuzirenXZP_Name:SetPoint("CENTER",chuzirenXZP,"CENTER",0,1);
		chuzirenXZP_Name:SetFont(ChatFontNormal:GetFont(), 12, "OUTLINE");
		chuzirenXZP_Name:SetText()
		chuzirenXZP_Name:Hide()
		local chuzirenXZP_Name_XS = chuzirenXZP:CreateFontString("chuzirenXZP_Name_XS_"..p.."_"..pp);
		chuzirenXZP_Name_XS:SetPoint("CENTER",chuzirenXZP,"CENTER",0,1);
		chuzirenXZP_Name_XS:SetFont(ChatFontNormal:GetFont(), 12, "OUTLINE");
		chuzirenXZP_Name_XS:SetText()
		_G["chuzirenXZP_"..p.."_"..pp]:SetScript("OnMouseDown", function (self)
			_G["chuzirenXZP_Name_XS_"..p.."_"..pp]:SetPoint("CENTER",self,"CENTER",1.5,-0.5);
		end);
		_G["chuzirenXZP_"..p.."_"..pp]:SetScript("OnMouseUp", function (self,button)
			_G["chuzirenXZP_Name_XS_"..p.."_"..pp]:SetPoint("CENTER",self,"CENTER",0,1);
			PIG["RaidRecord"]["fakuan"][tonumber(xuanzechuziren_T4:GetText())][4]=_G["chuzirenXZP_Name_"..p.."_"..pp]:GetText();
			UpdateFakuan(fakuan_Scroll_UI)
			xuanzechuziren_UI:Hide()
		end);
	end
end