local _, addonTable = ...;
local fuFrame=Pig_Options_RF_TAB_5_UI
-------
fuFrame.wupinxians = fuFrame:CreateLine()
fuFrame.wupinxians:SetColorTexture(1,1,1,0.4)
fuFrame.wupinxians:SetThickness(1);
fuFrame.wupinxians:SetStartPoint("TOPLEFT",3,-226)
fuFrame.wupinxians:SetEndPoint("TOPRIGHT",-2,-226)
---------
	-- SetAction = function(tt, slot)

	-- SetAuctionItem = function(tt, auctionType, index)
	-- local _, _, count = GetAuctionItemInfo(auctionType, index)

	-- SetAuctionSellItem = function(tt)
	-- local _, _, count = GetAuctionSellItemInfo()

	-- SetCraftItem = function(tt, index, reagent)
	-- local _, _, count = GetCraftReagentInfo(index, reagent)

	-- SetInboxItem = function(tt, messageIndex, attachIndex)
	-- local count, itemID
	-- if attachIndex then
	-- 	count = select(4, GetInboxItem(messageIndex, attachIndex))
	-- else
	-- 	count, itemID = select(14, GetInboxHeaderInfo(messageIndex))
	-- end
	-- SetInventoryItem = function(tt, unit, slot)
	-- 	local count
	-- 	if not CharacterBags[slot] then
	-- 		count = GetInventoryItemCount(unit, slot)
	-- 	end
	-- SetLootItem = function(tt, slot)
	-- local _, _, count = GetLootSlotInfo(slot)
	-- SetLootRollItem = function(tt, rollID)
	-- local _, _, count = GetLootRollItemInfo(rollID)
	-- SetSendMailItem = function(tt, index)
	-- 	local count = select(4, GetSendMailItem(index))
	-- SetTradePlayerItem = function(tt, index)
	-- 	local _, _, count = GetTradePlayerItemInfo(index)
	-- SetTradeSkillItem = function(tt, index, reagent)
	-- 	local count
	-- 	if reagent then
	-- 		count = select(3, GetTradeSkillReagentInfo(index, reagent))
	-- 	else 
	-- 		count = GetTradeSkillNumMade(index)
	-- 	end
	-- SetTradeTargetItem = function(tt, index)
	-- local _, _, count = GetTradeTargetItemInfo(index)
---------
local function Show_ItemSell()
	--全部提示
	-- GameTooltip:HookScript("OnTooltipSetItem", function(self)
	-- 	local _, link = self:GetItem()
	-- 	local itemSellG = select(11, GetItemInfo(link))
	-- 	if itemSellG then
	-- 		if itemSellG and itemSellG > 0 then
	-- 			SetTooltipMoney(self, itemSellG, nil, SELL_PRICE_TEXT)
	-- 		end
	-- 	end
	-- end)
	------
	hooksecurefunc(GameTooltip, "SetBagItem", function(self, bag, slot)
		if not MerchantFrame:IsVisible() then
			local _, link = self:GetItem()
			if link then
				local itemSellG = select(11, GetItemInfo(link))
				if itemSellG then
					local _, count = GetContainerItemInfo(bag, slot)
					if itemSellG and itemSellG > 0 then
						SetTooltipMoney(self, itemSellG*count, nil, SELL_PRICE_TEXT)
					end
					self:Show()
				end
			end
		end
	end)
	hooksecurefunc(GameTooltip, "SetQuestItem", function(self, questType, index)
		local _, link = self:GetItem()
		if link then
			local itemSellG = select(11, GetItemInfo(link))
			if itemSellG then
				local _, _, count = GetQuestItemInfo(questType, index)
				if itemSellG and itemSellG > 0 then
					SetTooltipMoney(self, itemSellG*count, nil, SELL_PRICE_TEXT)
				end
				self:Show()
			end
		end
	end)
	hooksecurefunc(GameTooltip, "SetQuestLogItem", function(self,  _, index)
		local _, link = self:GetItem()
		if link then
			local itemSellG = select(11, GetItemInfo(link))
			if itemSellG then
				local _, _, count = GetQuestLogRewardInfo(index)
				if itemSellG and itemSellG > 0 then
					SetTooltipMoney(self, itemSellG*count, nil, SELL_PRICE_TEXT)
				end
				self:Show()
			end
		end
	end)
end
-------------
local function Show_ItemLevel()
	GameTooltip:HookScript("OnTooltipSetItem", function(self)
		local _, link = self:GetItem()
		if link then
			local itemLevel = select(4, GetItemInfo(link))
			if itemLevel then
				self:AddDoubleLine("物品等级:",itemLevel)
				self:Show()
			end
		end
	end)
end
------
local function Show_SpellID()
	hooksecurefunc(GameTooltip, "SetUnitBuff", function(self, unit, index, filter)
		local _, icon, count, debuffType, duration, expires, caster,_,_,spellId = UnitBuff(unit, index, filter) 
	    if spellId then
	    	if caster then
		        local _, class = UnitClass(caster) 
		        local rPerc, gPerc, bPerc, argbHex = GetClassColor(class);
		        local name = GetUnitName(caster, true)
		        self:AddDoubleLine("来自:[\124c"..argbHex..name.."\124r]","SpellID:\124c"..argbHex..spellId.."\124r")
		        self:Show() 
			else
				self:AddDoubleLine("来自:[\124cff48cba0未知\124r]","SpellID:\124cff48cba0"..spellId.."\124r")
		        self:Show() 
			end
	    end
	end)
	hooksecurefunc(GameTooltip, "SetUnitDebuff", function(self, unit, index, filter)
		local _, icon, count, debuffType, duration, expires, caster,_,_,spellId = UnitDebuff(unit, index, filter) 
	    if spellId then
	    	if caster then
		        local _, class = UnitClass(caster) 
		        local rPerc, gPerc, bPerc, argbHex = GetClassColor(class);
		        local name = GetUnitName(caster, true)
		        self:AddDoubleLine("来自:[\124c"..argbHex..name.."\124r]","SpellID:\124c"..argbHex..spellId.."\124r")
		        self:Show() 
			else
				self:AddDoubleLine("来自:[\124cff48cba0未知\124r]","SpellID:\124cff48cba0"..spellId.."\124r")
		        self:Show() 
			end
	    end
	end)
	hooksecurefunc(GameTooltip, "SetUnitAura", function(self, unit, index, filter)
		local _, icon, count, debuffType, duration, expires, caster,_,_,spellId = UnitAura(unit, index, filter) 
	    if spellId then
	    	if caster then
		        local _, class = UnitClass(caster) 
		        local rPerc, gPerc, bPerc, argbHex = GetClassColor(class);
		        local name = GetUnitName(caster, true)
		        self:AddDoubleLine("来自:[\124c"..argbHex..name.."\124r]","SpellID:\124c"..argbHex..spellId.."\124r")
		        self:Show() 
			else
				self:AddDoubleLine("来自:[\124cff48cba0未知\124r]","SpellID:\124cff48cba0"..spellId.."\124r")
		        self:Show() 
			end
	    end 
	end)
	--处理聊天框物品/技能
	-- hooksecurefunc("SetItemRef", function(link, text, button, chatFrame)
	-- 	print("44")
	-- 	if string.find(link,"^spell:") then
	-- 		local id = string.sub(link,7)
	-- 		ItemRefTooltip:AddDoubleLine("SpellID:",id)
	-- 		ItemRefTooltip:Show()
	-- 	end
	-- end)
	GameTooltip:HookScript("OnTooltipSetSpell", function(self)
		local _,spellId = self:GetSpell()
		if spellId then
			self:AddDoubleLine("SpellID:",spellId)
			self:Show()
		end
	end)
end
--==========================================================
fuFrame.ItemSell = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.ItemSell:SetSize(30,32);
fuFrame.ItemSell:SetHitRectInsets(0,-100,0,0);
fuFrame.ItemSell:SetPoint("TOPLEFT",fuFrame.wupinxians,"TOPLEFT",20,-20);
fuFrame.ItemSell.Text:SetText("显示物品售价");
fuFrame.ItemSell.tooltip = "在鼠标提示上显示物品售价！";
fuFrame.ItemSell:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['ShowPlus']['ItemSell']="ON";
		Show_ItemSell()
	else
		PIG['ShowPlus']['ItemSell']="OFF";
		Pig_Options_RLtishi_UI:Show()
	end
end);
fuFrame.ItemLevel = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.ItemLevel:SetSize(30,32);
fuFrame.ItemLevel:SetHitRectInsets(0,-100,0,0);
fuFrame.ItemLevel:SetPoint("TOPLEFT",fuFrame.wupinxians,"TOPLEFT",300,-20);
fuFrame.ItemLevel.Text:SetText("显示物品等级");
fuFrame.ItemLevel.tooltip = "在鼠标提示上显示物品等级！";
fuFrame.ItemLevel:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['ShowPlus']['ItemLevel']="ON";
		Show_ItemLevel()
	else
		PIG['ShowPlus']['ItemLevel']="OFF";
		Pig_Options_RLtishi_UI:Show()
	end
end);
fuFrame.SpellID = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.SpellID:SetSize(30,32);
fuFrame.SpellID:SetHitRectInsets(0,-100,0,0);
fuFrame.SpellID:SetPoint("TOPLEFT",fuFrame.wupinxians,"TOPLEFT",20,-80);
fuFrame.SpellID.Text:SetText("显示技能ID/BUFF来源");
fuFrame.SpellID.tooltip = "在鼠标提示上显示技能ID/BUFF来源！";
fuFrame.SpellID:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['ShowPlus']['SpellID']="ON";
		Show_SpellID();
	else
		PIG['ShowPlus']['SpellID']="OFF";
		Pig_Options_RLtishi_UI:Show()
	end
end);
-------------
MainMenuBarBackpackButton.yushu = MainMenuBarBackpackButton:CreateFontString();
MainMenuBarBackpackButton.yushu:SetPoint("BOTTOMRIGHT", MainMenuBarBackpackButton, "BOTTOMRIGHT", -2, 4);
MainMenuBarBackpackButton.yushu:SetFont(ChatFontNormal:GetFont(), 18, "OUTLINE");
local function gengxinbeibaoshengyugeshu()
	local beibaoshengyushuliangduoshao = 0
	for bag=BACKPACK_CONTAINER, NUM_BAG_SLOTS do 
		local numberOfFreeSlots=GetContainerNumFreeSlots(bag);
		beibaoshengyushuliangduoshao=beibaoshengyushuliangduoshao+numberOfFreeSlots
	end
	MainMenuBarBackpackButton.yushu:SetText(beibaoshengyushuliangduoshao); 
	if beibaoshengyushuliangduoshao<10 then
		MainMenuBarBackpackButton.yushu:SetTextColor(1, 0, 0, 1);
	else
		MainMenuBarBackpackButton.yushu:SetTextColor(0, 1, 0, 1);
	end
end
local PIG_BagshengyuFFFF = CreateFrame("Frame");
fuFrame.BAGkongyu = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.BAGkongyu:SetSize(30,32);
fuFrame.BAGkongyu:SetHitRectInsets(0,-100,0,0);
fuFrame.BAGkongyu:SetPoint("TOPLEFT",fuFrame.wupinxians,"TOPLEFT",300,-80);
fuFrame.BAGkongyu.Text:SetText("显示背包剩余格数");
fuFrame.BAGkongyu.tooltip = "在背包上显示背包的总剩余格数！";
fuFrame.BAGkongyu:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['ShowPlus']['BAGkongyu']="ON";
		gengxinbeibaoshengyugeshu()
		PIG_BagshengyuFFFF:RegisterEvent("BAG_UPDATE");
		MainMenuBarBackpackButton.yushu:Show()
	else
		PIG['ShowPlus']['BAGkongyu']="OFF";
		PIG_BagshengyuFFFF:UnregisterEvent("BAG_UPDATE");
		MainMenuBarBackpackButton.yushu:Hide()
	end
end);
PIG_BagshengyuFFFF:SetScript("OnEvent", function(self,event,arg1)
	if PIG['ShowPlus']['BAGkongyu']=="ON" then
		gengxinbeibaoshengyugeshu()
	end
end);
--加载设置---------------
addonTable.ShowPlus = function()
	PIG["ShowPlus"] = PIG["ShowPlus"] or addonTable.Default["ShowPlus"]
	PIG['ShowPlus']['BAGkongyu']=PIG['ShowPlus']['BAGkongyu'] or addonTable.Default['ShowPlus']['BAGkongyu']
	if PIG['ShowPlus']['ItemSell']=="ON" then
		fuFrame.ItemSell:SetChecked(true);
		Show_ItemSell()
	end
	if PIG['ShowPlus']['ItemLevel']=="ON" then
		fuFrame.ItemLevel:SetChecked(true);
		Show_ItemLevel()
	end
	if PIG['ShowPlus']['SpellID']=="ON" then
		fuFrame.SpellID:SetChecked(true);
		Show_SpellID()
	end
	if PIG['ShowPlus']['BAGkongyu']=="ON" then
		fuFrame.BAGkongyu:SetChecked(true);
		PIG_BagshengyuFFFF:RegisterEvent("BAG_UPDATE");
	end
end
