local addonName, addonTable = ...;
local fuFrame=Pig_Options_RF_TAB_2_UI
--========================================================
local function ADD_guanjianzi_open()
	local guanjianzi = CreateFrame("Button","guanjianzi_UI",UIParent, "UIMenuButtonStretchTemplate"); 
	guanjianzi:SetSize(27,26);
	guanjianzi:SetFrameStrata("LOW")
	guanjianzi:SetPoint("BOTTOM",ChatFrameChannelButton,"TOP",0,56);
	guanjianzi.Tex = guanjianzi:CreateTexture();
	guanjianzi.Tex:SetTexture("interface/common/voicechat-on.blp");
	guanjianzi.Tex:SetSize(26,20);
	guanjianzi.Tex:SetPoint("CENTER", -8, 0);
	guanjianzi:SetScript("OnMouseDown",  function(self)
		self.Tex:SetPoint("CENTER", -9, -1.5);
	end)
	guanjianzi:SetScript("OnMouseUp",  function(self)
		self.Tex:SetPoint("CENTER", -8, 0);
	end)
	guanjianzi.F = CreateFrame("Frame", "guanjianzi_F_UI", guanjianzi,"BackdropTemplate");
	guanjianzi.F:SetBackdrop( { bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 4,} );
	guanjianzi.F:SetBackdropBorderColor(1, 1, 1, 0.6);
	guanjianzi.F:SetSize(DEFAULT_CHAT_FRAME:GetWidth()+2,200);
	guanjianzi.F:SetPoint("BOTTOMLEFT",guanjianzi,"TOPRIGHT",4,0);
	guanjianzi.F:Hide();
	tinsert(UISpecialFrames,"guanjianzi_F_UI");

	guanjianzi.F.ends = CreateFrame("Button",nil,guanjianzi.F, "TruncatedButtonTemplate");
	guanjianzi.F.ends:SetNormalTexture("interface/chatframe/ui-chaticon-scrollend-up.blp")
	guanjianzi.F.ends:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	guanjianzi.F.ends:SetPushedTexture("interface/chatframe/ui-chaticon-scrollend-down.blp")
	guanjianzi.F.ends:SetSize(30,30);
	guanjianzi.F.ends:SetPoint("BOTTOMLEFT",guanjianzi.F,"BOTTOMRIGHT",0,4);
	guanjianzi.F.down = CreateFrame("Button",nil,guanjianzi.F, "TruncatedButtonTemplate");
	guanjianzi.F.down:SetNormalTexture("interface/chatframe/ui-chaticon-scrolldown-up.blp")
	guanjianzi.F.down:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	guanjianzi.F.down:SetPushedTexture("interface/chatframe/ui-chaticon-scrolldown-down.blp")
	guanjianzi.F.down:SetSize(30,30);
	guanjianzi.F.down:SetPoint("BOTTOM",guanjianzi.F.ends,"TOP",0,4);
	guanjianzi.F.up = CreateFrame("Button",nil,guanjianzi.F, "TruncatedButtonTemplate");
	guanjianzi.F.up:SetNormalTexture("interface/chatframe/ui-chaticon-scrollup-up.blp")
	guanjianzi.F.up:SetHighlightTexture("interface/buttons/ui-common-mousehilight.blp");
	guanjianzi.F.up:SetPushedTexture("interface/chatframe/ui-chaticon-scrollup-down.blp")
	guanjianzi.F.up:SetSize(30,30);
	guanjianzi.F.up:SetPoint("BOTTOM",guanjianzi.F.down,"TOP",0,4);

	guanjianzi.F.Scroll = CreateFrame("ScrollingMessageFrame", nil, guanjianzi.F, "ChatFrameTemplate")
	guanjianzi.F.Scroll:SetPoint("TOPLEFT",guanjianzi.F,"TOPLEFT",0,0);
	guanjianzi.F.Scroll:SetPoint("BOTTOMRIGHT",guanjianzi.F,"BOTTOMRIGHT",0,0);
	--guanjianzi.F.Scroll:SetFading(false)
	--guanjianzi.F.Scroll:SetMaxLines(999)
	guanjianzi.F.Scroll:UnregisterAllEvents()
	--guanjianzi.F.Scroll:SetFrameStrata("HIGH")
	--guanjianzi.F.Scroll:SetToplevel(false)
	--guanjianzi.F.Scroll:Hide()
	guanjianzi.F.Scroll:SetHyperlinksEnabled(true)
	--guanjianzi.F.Scroll:EnableMouseWheel(true)
	guanjianzi.F.Scroll:SetScript("OnMouseWheel", function(self, delta)
		if delta == 1 then
			guanjianzi.F.down:SetNormalTexture("interface/chatframe/ui-chaticon-scrolldown-up.blp")
			guanjianzi.F.ends:SetNormalTexture("interface/chatframe/ui-chaticon-scrollend-up.blp")
			guanjianzi.F.Scroll:ScrollUp()
		elseif delta == -1 then
			guanjianzi.F.up:SetNormalTexture("interface/chatframe/ui-chaticon-scrollup-up.blp")
			guanjianzi.F.Scroll:ScrollDown()
		end
	end)

	guanjianzi:SetScript("OnClick", function(self)
		if self.F:IsShown() then
			self.F:Hide()
		else
			self.F:Show()
		end
	end);
end

--精简频道名
local function zhixingjingjianpindao()
	local gsub = _G.string.gsub  
	for i = 1, NUM_CHAT_WINDOWS do
		if ( i ~= 2 ) then
			local chatID = _G["ChatFrame"..i]
			local msninfo = chatID.AddMessage
			chatID.AddMessage = function(frame, text, ...)
				--table.insert(PIG['Chatjilu']["pindao"][3]["neirong"][2][1], {text});
				if PIG['ChatFrame']['jingjian']=="ON" then
					local msninfoYES=string.find(text, "大脚世界频道", 1)
					local msninfoYES1=string.find(text, "寻求组队", 1)
					local msninfoYES2=string.find(text, "PIG", 1)
					if msninfoYES then
						return msninfo(frame, text:gsub('|h%[(%d+)%. 大脚世界频道%]|h', '|h%[%1%. 世%]|h'), ...)
					elseif msninfoYES1 then
						return msninfo(frame, text:gsub('|h%[(%d+)%. 寻求组队%]|h', '|h%[%1%. 组%]|h'), ...)
					elseif msninfoYES2 then
						local Guolvweimian=string.find(text, "请求位面信息", 1)
						local GuolvChedui=string.find(text, "请求车队信息", 1)
						if Guolvweimian or GuolvChedui then
							return msninfo(frame, "|cff222222"..text.."|r", ...)
						else
						--if PIG['ChatFrame']['guanjianzi']=="ON" then
							return msninfo(frame, "|cff66ffcc"..text.."|r", ...)
						-- else
						-- 	return msninfo(frame, text, ...)
						end
					else
						return msninfo(frame, text, ...)
					end
				else
					local Guolvweimian=string.find(text, "请求位面信息", 1)
					local GuolvChedui=string.find(text, "请求车队信息", 1)
					if Guolvweimian or GuolvChedui then
						return msninfo(frame, "|cff222222"..text.."|r", ...)
					else
						return msninfo(frame, text, ...)
					end
				end
			end
		end
	end
end

fuFrame.guanjianzi = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.guanjianzi:SetSize(30,32);
fuFrame.guanjianzi:SetHitRectInsets(0,-120,0,0);
fuFrame.guanjianzi:SetPoint("TOPLEFT",fuFrame.QCxian,"BOTTOMLEFT",300,-64);
fuFrame.guanjianzi.Text:SetText("聊天关键字单独提醒");
fuFrame.guanjianzi.tooltip = "新建一个单独聊天框提示已设置的关键字聊天";
fuFrame.guanjianzi:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['ChatFrame']['guanjianzi']="ON";
		ADD_guanjianzi_open()
	else
		PIG['ChatFrame']['guanjianzi']="OFF";
	end
end);

--------------------------------------------
addonTable.ChatFrame_ChatKeyword = function()
	PIG['ChatFrame']['guanjianzi']=PIG['ChatFrame']['guanjianzi'] or addonTable.Default['ChatFrame']['guanjianzi']
	if PIG['ChatFrame']['guanjianzi']=="ON" then
		fuFrame.guanjianzi:SetChecked(true);
		ADD_guanjianzi_open()
	end
end