local _, addonTable = ...;
-------
local Width,Height  = RaidR_UI:GetWidth(), RaidR_UI:GetHeight();
--=====================================================================
--设置按钮
local Rsetting = CreateFrame("Button","Rsetting_UI",xiafangFrame_UI, "TruncatedButtonTemplate"); 
Rsetting:SetNormalTexture("interface/gossipframe/healergossipicon.blp"); 
Rsetting:SetHighlightTexture(130718);
Rsetting:SetSize(22,22);
Rsetting:SetPoint("TOPLEFT",xiafangFrame_UI,"TOPLEFT",Width-70,-44);
local Rsetting_Down = Rsetting:CreateTexture("Rsetting_Down_UI", "OVERLAY");
Rsetting_Down:SetTexture(130839);
Rsetting_Down:SetSize(22,22);
Rsetting_Down:SetPoint("CENTER");
Rsetting_Down:Hide();
--内容页-------------------------
local RsettingF = CreateFrame("Frame", "RsettingF_UI", Rsetting,"BackdropTemplate");
RsettingF:SetBackdrop({bgFile = "interface/raidframe/ui-raidframe-groupbg.blp", 
	edgeFile = "interface/glues/common/textpanel-border.blp", 
	tile = false, tileSize = 0, edgeSize = 20,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
RsettingF:SetSize(Width-40,Height-104);
RsettingF:SetPoint("TOP",RaidR_UI,"TOP",0,-18);
RsettingF:SetFrameLevel(20);
RsettingF:EnableMouse(true);
tinsert(UISpecialFrames,"RsettingF_UI");
local RsettingF_Close = CreateFrame("Button","RsettingF_Close_UI",RsettingF, "UIPanelCloseButton");  
RsettingF_Close:SetSize(34,34);
RsettingF_Close:SetPoint("TOPRIGHT",RsettingF,"TOPRIGHT",2.4,0);
local RsettingF_biaoti = RsettingF:CreateFontString("RsettingF_biaoti_UI");
RsettingF_biaoti:SetPoint("TOP",RsettingF,"TOP",0,-10);
RsettingF_biaoti:SetFont(ChatFontNormal:GetFont(), 16, "OUTLINE");
RsettingF_biaoti:SetText("\124cff00FF00副本助手设置\124r");
local RsettingF_X = RsettingF:CreateLine()
RsettingF_X:SetColorTexture(1,1,1,0.3)
RsettingF_X:SetThickness(2);
RsettingF_X:SetStartPoint("TOPLEFT",5,-34)
RsettingF_X:SetEndPoint("TOPRIGHT",-3,-34)

--内部内容======================================
--副本外
local RsettingF_fubenwai = CreateFrame("CheckButton", "RsettingF_fubenwai_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_fubenwai:SetSize(30,30);
RsettingF_fubenwai:SetHitRectInsets(0,0,0,0);
RsettingF_fubenwai:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",20,-50);
RsettingF_fubenwai_UIText:SetText("记录副本外");
RsettingF_fubenwai.tooltip = "开启后会记录副本外的拾取信息（默认只记录团队副本内掉落）。";
RsettingF_fubenwai:SetScript("OnClick", function ()
	if RsettingF_fubenwai:GetChecked() then
		PIG["RaidRecord"]["RsettingF_fubenwai"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_fubenwai"]="OFF";
	end
end);
--5人本
local RsettingF_wurenben = CreateFrame("CheckButton", "RsettingF_wurenben_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_wurenben:SetSize(30,30);
RsettingF_wurenben:SetHitRectInsets(0,0,0,0);
RsettingF_wurenben:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",260,-50);
RsettingF_wurenben_UIText:SetText("记录5人本");
RsettingF_wurenben.tooltip = "开启后会记录5人本拾取信息（默认只记录团队副本内掉落）。";
RsettingF_wurenben:SetScript("OnClick", function ()
	if RsettingF_wurenben:GetChecked() then
		PIG["RaidRecord"]["RsettingF_wurenben"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_wurenben"]="OFF";
	end
end);
--======================================================
--拾取物品倒计时
local function ITEMTimetishi()
	if PIG["RaidRecord"]["RsettingF_jiaoyidaojishi"]=="ON" and PIG["RaidRecord"]["Kaiqi"]=="ON" then
		if #PIG["RaidRecord"]["ItemList"]>0 then
			for i=1,#PIG["RaidRecord"]["ItemList"],1 do
				if PIG["RaidRecord"]["ItemList"][i][8]~="无" then--已有成交人
					PIG["RaidRecord"]["ItemList"][i][13]=false;
					addonTable.RaidRecord_UpdateItem(Item_Scroll_UI);
				else
					if PIG["RaidRecord"]["ItemList"][i][13] then
						local yijingguoqu=GetServerTime()-PIG["RaidRecord"]["ItemList"][i][1];
						if yijingguoqu>7200 then
							PIG["RaidRecord"]["ItemList"][i][13]=false;	
							addonTable.RaidRecord_UpdateItem(Item_Scroll_UI);
						elseif yijingguoqu>6600 then
							if PIG["RaidRecord"]["ItemList"][i][12] then
								if UnitIsGroupLeader("player", "LE_PARTY_CATEGORY_HOME") and IsInRaid("LE_PARTY_CATEGORY_HOME") then
									SendChatMessage("提示：未成交物品"..PIG["RaidRecord"]["ItemList"][i][2].."可交易时间不足10分钟，请确认物品归属(预估时间仅供参考)！","RAID", nil);
									PIG["RaidRecord"]["ItemList"][i][12]=false;
									addonTable.RaidRecord_UpdateItem(Item_Scroll_UI);
								end
							end
						end
					end	
				end
			end
		end
		C_Timer.After(10,ITEMTimetishi);
	end
end
----
local RsettingF_jiaoyidaojishi = CreateFrame("CheckButton", "RsettingF_jiaoyidaojishi_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_jiaoyidaojishi:SetSize(30,30);
RsettingF_jiaoyidaojishi:SetHitRectInsets(0,0,0,0);
RsettingF_jiaoyidaojishi:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",260,-100);
RsettingF_jiaoyidaojishi_UIText:SetText("物品交易倒计时通告");
RsettingF_jiaoyidaojishi.tooltip = "启用后，物品可交易时间低于10分钟将会在团队频道提示，预估时间仅供参考。";
RsettingF_jiaoyidaojishi:SetScript("OnClick", function ()
	if RsettingF_jiaoyidaojishi:GetChecked() then
		PIG["RaidRecord"]["RsettingF_jiaoyidaojishi"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_jiaoyidaojishi"]="OFF";
	end
	ITEMTimetishi();
end);

--=====================================================
--手动添加物品
local RsettingF_shoudongloot = CreateFrame("CheckButton", "RsettingF_shoudongloot_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_shoudongloot:SetSize(30,30);
RsettingF_shoudongloot:SetHitRectInsets(0,0,0,0);
RsettingF_shoudongloot:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",20,-100);
RsettingF_shoudongloot_UIText:SetText("手动添加物品");
RsettingF_shoudongloot.tooltip = "开启后按住shift点击聊天栏物品链接添加物品到拾取目录（注意必须保持拾取目录列表为打开状态）。";
RsettingF_shoudongloot:SetScript("OnClick", function ()
	if RsettingF_shoudongloot:GetChecked() then
		PIG["RaidRecord"]["RsettingF_shoudongloot"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_shoudongloot"]="OFF";
	end
end);

--=================================================================
--过滤排除物品
local paichu_Height,paichu_NUM  = 28, 14;
local function gengxinpaichu(self)
	for q = 1, paichu_NUM do
		_G["Pcwupin_item_icon_"..q.."_UI"]:SetTexture();
		_G["Pcwupin_item_link_"..q.."_UI"]:SetText();
		_G["Pcwupin_item_"..q.."_UI"]:Hide();
		_G["Pcwupin_del_"..q.."_UI"]:Hide();
    end
	if #PIG["RaidRecord"]["ItemList_Paichu"]>0 then
		local ItemsNum = #PIG["RaidRecord"]["ItemList_Paichu"];
		FauxScrollFrame_Update(self, ItemsNum, paichu_NUM, paichu_Height);
		local offset = FauxScrollFrame_GetOffset(self);
	    if ItemsNum<paichu_NUM then
	    	New_DELpaichu_NUM=ItemsNum;
	    else
	    	New_DELpaichu_NUM=paichu_NUM;
	    end
		for k = 1, New_DELpaichu_NUM do
			local dangqianH = k+offset;
			local itemName, itemLink, _, _, _, _, _, _,_, itemTexture=GetItemInfo(PIG["RaidRecord"]["ItemList_Paichu"][dangqianH]);
	    	_G["Pcwupin_item_icon_"..k.."_UI"]:SetTexture(itemTexture);
			_G["Pcwupin_item_link_"..k.."_UI"]:SetText(itemLink);
			_G["Pcwupin_item_"..k.."_UI"]:Show();
			_G["Pcwupin_item_"..k.."_UI"]:SetScript("OnMouseDown", function ()
				GameTooltip:ClearLines();
				GameTooltip:SetOwner(_G["Pcwupin_item_link_"..k.."_UI"], "ANCHOR_CURSOR");
				GameTooltip:SetHyperlink(itemLink)
			end);
			_G["Pcwupin_item_"..k.."_UI"]:SetScript("OnMouseUp", function ()
				GameTooltip:ClearLines();
				GameTooltip:Hide() 
			end);
			_G["Pcwupin_del_"..k.."_UI"]:Show();
			_G["Pcwupin_del_"..k.."_UI"]:SetID(dangqianH);
		end
	end
end

--父框架
local Paichu = CreateFrame("Frame", "Paichu_UI", RsettingF)
Paichu:SetSize(Width/3, Height-144)
Paichu:SetPoint("RIGHT", RsettingF, "RIGHT", -2, -16)
local Paichu_line = Paichu:CreateLine()
Paichu_line:SetColorTexture(1,1,1,0.3)
Paichu_line:SetThickness(2);
Paichu_line:SetStartPoint("TOPLEFT",0,-30)
Paichu_line:SetEndPoint("TOPRIGHT",0,-30)
local Paichu_line1 = Paichu:CreateLine()
Paichu_line1:SetColorTexture(1,1,1,0.3)
Paichu_line1:SetThickness(2);
Paichu_line1:SetStartPoint("TOPLEFT",0,1)
Paichu_line1:SetEndPoint("BOTTOMLEFT",0,0)
local Paichu_biaoti = Paichu:CreateFontString();
Paichu_biaoti:SetPoint("TOPLEFT", Paichu, "TOPLEFT", 4, -7);
Paichu_biaoti:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");
Paichu_biaoti:SetText("\124cffFFFF00拾取过滤目录\124r\124cff00FF00(以下物品拾取不记录)\124r");
--快照提示
local Paichu_biaoti_tishi = CreateFrame("Frame", "Paichu_biaoti_tishi_UI", Paichu);
Paichu_biaoti_tishi:SetSize(30,30);
Paichu_biaoti_tishi:SetPoint("LEFT",Paichu_biaoti,"RIGHT",-6,0);
local Paichu_biaoti_tishi_Texture = Paichu_biaoti_tishi:CreateTexture("Paichu_biaoti_tishi_Texture_UI", "BORDER");
Paichu_biaoti_tishi_Texture:SetTexture("interface/common/help-i.blp");
Paichu_biaoti_tishi_Texture:SetAllPoints(Paichu_biaoti_tishi)
Paichu_biaoti_tishi:SetScript("OnEnter", function ()
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(Paichu_biaoti_tishi, "ANCHOR_TOPLEFT",0,0);
	GameTooltip:AddLine("提示：")
	GameTooltip:AddLine("\124cff00ff00右键点击拾取记录物品名添加为不记录.\124r")
	GameTooltip:Show();
end);
Paichu_biaoti_tishi:SetScript("OnLeave", function ()
	GameTooltip:ClearLines();
	GameTooltip:Hide() 
end);
----可滚动区域
local Paichu_Scroll = CreateFrame("ScrollFrame","Paichu_Scroll_UI",Paichu, "FauxScrollFrameTemplate");  
Paichu_Scroll:SetPoint("TOPLEFT",Paichu,"TOPLEFT",0,-32);
Paichu_Scroll:SetPoint("BOTTOMRIGHT",Paichu,"BOTTOMRIGHT",-25,2);
Paichu_Scroll:SetScript("OnVerticalScroll", function(self, offset)
    FauxScrollFrame_OnVerticalScroll(self, offset, paichu_Height, gengxinpaichu)
end)
--创建行
for id = 1, paichu_NUM do
	local Pcwupin = CreateFrame("Frame", "Pcwupin_"..id.."_UI", Paichu_Scroll:GetParent());
	Pcwupin:SetSize(Width/3-30, paichu_Height);
	if id==1 then
		Pcwupin:SetPoint("TOP",Paichu_Scroll,"TOP",0,0);
	else
		Pcwupin:SetPoint("TOP",_G["Pcwupin_"..(id-1).."_UI"],"BOTTOM",0,-0);
	end
	if id~=paichu_NUM then
		local Pcwupin_line = Pcwupin:CreateLine()
		Pcwupin_line:SetColorTexture(1,1,1,0.2)
		Pcwupin_line:SetThickness(1.2);
		Pcwupin_line:SetStartPoint("BOTTOMLEFT",0,0.2)
		Pcwupin_line:SetEndPoint("BOTTOMRIGHT",0,0.2)
	end
	local Pcwupin_item = CreateFrame("Frame", "Pcwupin_item_"..id.."_UI", Pcwupin);
	Pcwupin_item:SetSize(Width/3-68,paichu_Height);
	Pcwupin_item:SetPoint("LEFT",Pcwupin,"LEFT",34,0);
	local Pcwupin_item_icon = Pcwupin_item:CreateTexture("Pcwupin_item_icon_"..id.."_UI", "BORDER");
	Pcwupin_item_icon:SetSize(paichu_Height-4,paichu_Height-4);
	Pcwupin_item_icon:SetPoint("LEFT", Pcwupin_item, "LEFT", 0,0);
	local Pcwupin_item_link = Pcwupin_item:CreateFontString("Pcwupin_item_link_"..id.."_UI");
	Pcwupin_item_link:SetPoint("LEFT", Pcwupin_item, "LEFT", 30,0);
	Pcwupin_item_link:SetFont(ChatFontNormal:GetFont(), 14, "OUTLINE");

	local Pcwupin_del = CreateFrame("Button","Pcwupin_del_"..id.."_UI",Pcwupin, "TruncatedButtonTemplate");
	Pcwupin_del:SetSize(22,22);
	Pcwupin_del:SetPoint("LEFT", Pcwupin, "LEFT", 5,0);
	local Texture_del = Pcwupin_del:CreateTexture(nil, "BORDER");
	Texture_del:SetTexture("interface/common/voicechat-muted.blp");
	Texture_del:SetPoint("CENTER");
	Texture_del:SetSize(15,15);
	Pcwupin_del:SetScript("OnMouseDown", function ()
		Texture_del:SetPoint("CENTER",-1.5,-1.5);
	end);
	Pcwupin_del:SetScript("OnMouseUp", function ()
		Texture_del:SetPoint("CENTER");
	end);
	Pcwupin_del:SetScript("OnClick", function (self)
		local Pcwupin_delID =self:GetID()
		table.remove(PIG["RaidRecord"]["ItemList_Paichu"], Pcwupin_delID);
		gengxinpaichu(Paichu_Scroll_UI);
	end);
end
----
-- local Paichu_ADD = CreateFrame("Frame","Paichu_ADD_UI",Paichu);  
-- Paichu_ADD:SetPoint("TOPLEFT",Paichu,"TOPLEFT",10,-32);
-- Paichu_ADD:SetPoint("BOTTOMRIGHT",Paichu,"BOTTOMRIGHT",-28,7);
-- ---
-- local paichu_iteminfo=nil;
-- Paichu:RegisterEvent("ITEM_LOCK_CHANGED");
-- Paichu:SetScript("OnEvent",function (self,event,arg1,arg2)
-- 	if arg1 and arg2 then
-- 		if CursorHasItem() then
-- 			local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(arg1,arg2);
-- 			paichu_iteminfo=itemID;
-- 			Paichu_ADD:SetFrameLevel(5);
-- 		end
-- 	end
-- end);
-- Paichu_ADD:SetScript("OnMouseUp", function ()
-- 	if CursorHasItem() then
-- 		for i=1,#PIG["RaidRecord"]["ItemList_Paichu"] do
-- 			if paichu_iteminfo==PIG["RaidRecord"]["ItemList_Paichu"][i] then
-- 				print("|cff00FFFF!Pig:|r|cffffFF00物品已在目录内！|r");
-- 				ClearCursor();
-- 				paichu_iteminfo=nil;
-- 				return
-- 			end
-- 		end
-- 		table.insert(PIG["RaidRecord"]["ItemList_Paichu"], paichu_iteminfo);
-- 		ClearCursor();
-- 		paichu_iteminfo=nil;
-- 		gengxinpaichu(Paichu_Scroll);
-- 	end
-- 	Paichu_ADD:SetFrameLevel(2);
-- end);

--==========================================================
--交易记录
local jiaoyijiluFFFF = CreateFrame("Frame")
-- 注册接收插件广播的交易信息
C_ChatInfo.RegisterAddonMessagePrefix('!Pig-jiaoyi')
jiaoyijiluFFFF:RegisterEvent('CHAT_MSG_ADDON');

local guangbopindao="RAID";
local jiaoyishujuinfo={{},0,{},0}
jiaoyijiluFFFF:SetScript("OnEvent",function (self,event,arg1,arg2,arg3,arg4,arg5)
	if event=="CHAT_MSG_ADDON" then
		--local name, realm = UnitName("player")
		local namerealm = GetUnitName("player");
		if arg1 == '!Pig-jiaoyi' and arg5 ~= namerealm then
			local _, _, _, wupinID = string.find(arg2, "((.+)姓名)");
			local _, _, _, wanjiaName = string.find(arg2, "(姓名(.+)金额)");
			local _, _,_, jiaoyijine = string.find(arg2, "(金额(.+))");			  
			for x=1,#PIG["RaidRecord"]["ItemList"] do
				if tonumber(wupinID)==PIG["RaidRecord"]["ItemList"][x][11] then
					if PIG["RaidRecord"]["ItemList"][x][8]=="无" and PIG["RaidRecord"]["ItemList"][x][9]==0 then
						PIG["RaidRecord"]["ItemList"][x][8]=wanjiaName;
						PIG["RaidRecord"]["ItemList"][x][9]=tonumber(jiaoyijine);
						PIG["RaidRecord"]["ItemList"][x][10]=GetServerTime();
						addonTable.RaidRecord_UpdateItem(Item_Scroll_UI);
						break
					end
				end
			end
	    end
	end
	if event=="TRADE_SHOW" then
		jiaoyishujuinfo={{},0,{},0}
	end
	if event=="TRADE_PLAYER_ITEM_CHANGED" or event=="TRADE_TARGET_ITEM_CHANGED" or event=="TRADE_ACCEPT_UPDATE" or event=="TRADE_MONEY_CHANGED" then
		jiaoyishujuinfo={{},0,{},0}
		for i=1,6 do
			local PPPItemlink = GetTradePlayerItemLink(i);
			if PPPItemlink then
				local PPPname, PPPtexture, PPPquantity = GetTradePlayerItemInfo(i)
				table.insert(jiaoyishujuinfo[1],{PPPItemlink,PPPquantity});
			end
			local TTTItemlink = GetTradeTargetItemLink(i);
			if TTTItemlink then
				local TTTname, TTTtexture, TTTquantity = GetTradeTargetItemInfo(i)
				table.insert(jiaoyishujuinfo[3],{TTTItemlink,TTTquantity});
			end
		end
		jiaoyishujuinfo[2]=GetPlayerTradeMoney();
		jiaoyishujuinfo[4]=GetTargetTradeMoney();
	end
	if event=="UI_INFO_MESSAGE" then
		if arg2=="交易完成" then
			if #jiaoyishujuinfo[1]>1 then
				local fubenzhushou_chenggongjiaoyi = false
				for x=1,#jiaoyishujuinfo[1] do
					local zijiitemID = GetItemInfoInstant(jiaoyishujuinfo[1][x][1]);
					for xx=1,#PIG["RaidRecord"]["ItemList"] do
						if zijiitemID==PIG["RaidRecord"]["ItemList"][xx][11] then
							if PIG["RaidRecord"]["ItemList"][xx][8]=="无" and PIG["RaidRecord"]["ItemList"][xx][9]==0 then
								fubenzhushou_chenggongjiaoyi = true
								local wanjia = TradeFrameRecipientNameText:GetText()
								PIG["RaidRecord"]["ItemList"][xx][8]=wanjia;
								addonTable.RaidRecord_UpdateItem(Item_Scroll_UI);
								C_ChatInfo.SendAddonMessage('!Pig-jiaoyi', zijiitemID..'姓名'..wanjia..'金额'..0, guangbopindao);-- 发送此次交易给其他使用者
								break
							end
						end
					end
				end
				if fubenzhushou_chenggongjiaoyi then
					print("|cff00FFFF!Pig:|r|cffFFFF00一次交易多件物品请手动输入每件物品的成交价！|r")
				end
			elseif #jiaoyishujuinfo[1]==1 then
				local zijiitemID = GetItemInfoInstant(jiaoyishujuinfo[1][1][1]);
				for x=1,#PIG["RaidRecord"]["ItemList"] do
					if zijiitemID==PIG["RaidRecord"]["ItemList"][x][11] then
						if PIG["RaidRecord"]["ItemList"][x][8]=="无" and PIG["RaidRecord"]["ItemList"][x][9]==0 then
							local wanjia = TradeFrameRecipientNameText:GetText()
							PIG["RaidRecord"]["ItemList"][x][8]=wanjia;
							PIG["RaidRecord"]["ItemList"][x][9]=jiaoyishujuinfo[4]/10000;
							PIG["RaidRecord"]["ItemList"][x][10]=GetServerTime();
							addonTable.RaidRecord_UpdateItem(Item_Scroll_UI);
							C_ChatInfo.SendAddonMessage('!Pig-jiaoyi', zijiitemID..'姓名'..wanjia..'金额'..(jiaoyishujuinfo[4]/10000), guangbopindao);-- 发送此次交易给其他使用者
							break
						end
					end
				end
			elseif #jiaoyishujuinfo[1]==0 then
				for x=1,#PIG["RaidRecord"]["fakuan"] do
					local wanjia = TradeFrameRecipientNameText:GetText()
					if PIG["RaidRecord"]["fakuan"][x][4]==wanjia then
						PIG["RaidRecord"]["fakuan"][x][2]=PIG["RaidRecord"]["fakuan"][x][2]+jiaoyishujuinfo[4]/10000;
						if PIG["RaidRecord"]["fakuan"][x][3]>0 then
							PIG["RaidRecord"]["fakuan"][x][3]=PIG["RaidRecord"]["fakuan"][x][3]-jiaoyishujuinfo[4]/10000;
						end
						addonTable.RaidRecord_UpdateFakuan(fakuan_Scroll_UI);
						break
					end
				end
			end
			--从物品目录剔除交易收到的物品
			if #jiaoyishujuinfo[3]>0 then
				for x=1,#jiaoyishujuinfo[3] do
					for v = #PIG["RaidRecord"]["ItemList"], 1, -1 do
						if jiaoyishujuinfo[3][x][1]==PIG["RaidRecord"]["ItemList"][v][2] then
							table.remove(PIG["RaidRecord"]["ItemList"],v);
							break
						end
					end
					for d =1, #PIG["RaidRecord"]["ItemList"] , 1 do
						if jiaoyishujuinfo[3][x][1]==PIG["RaidRecord"]["ItemList"][d][2] then
							PIG["RaidRecord"]["ItemList"][d][3]=PIG["RaidRecord"]["ItemList"][d][3]-jiaoyishujuinfo[3][x][2];
						end
					end
					addonTable.RaidRecord_UpdateItem(Item_Scroll_UI)
				end
			end
			--喊话
			-- local wanjia = TradeFrameRecipientNameText:GetText()
			-- local jiaoyiMSGinfo="与"..wanjia.."交易成功,";
			-- if #jiaoyishujuinfo[1]>0 then
			-- 	jiaoyiMSGinfo=jiaoyiMSGinfo.."交出："
			-- 	for x=1,#jiaoyishujuinfo[1] do
			-- 		jiaoyiMSGinfo=jiaoyiMSGinfo..jiaoyishujuinfo[1][x][1](jiaoyishujuinfo[1][x][2]).." "
			-- 	end
			-- end
			-- if jiaoyishujuinfo[2]>0 then
			-- 	jiaoyiMSGinfo=jiaoyiMSGinfo.."付出："..(jiaoyishujuinfo[2]/10000).."G"
			-- end
			-- if #jiaoyishujuinfo[3]>0 then
			-- 	jiaoyiMSGinfo=jiaoyiMSGinfo.."收到："
			-- 	for x=1,#jiaoyishujuinfo[3] do
			-- 		jiaoyiMSGinfo=jiaoyiMSGinfo..jiaoyishujuinfo[3][x][1](jiaoyishujuinfo[1][x][2]).." "
			-- 	end
			-- end
			-- if jiaoyishujuinfo[4]>0 then
			-- 	jiaoyiMSGinfo=jiaoyiMSGinfo.."收入："..(jiaoyishujuinfo[4]/10000).."G"
			-- end
			-- if IsInRaid("LE_PARTY_CATEGORY_HOME") then
			-- 	SendChatMessage(jiaoyiMSGinfo,"RAID", nil);
			-- elseif IsInGroup("LE_PARTY_CATEGORY_HOME") then
			-- 	SendChatMessage(jiaoyiMSGinfo,"PARTY", nil);
			-- end
		end
		if arg2=="交易取消" then
			jiaoyishujuinfo={{},0,{},0}
		end
	end
end)
local  function jiaoyijiluFun()
	if PIG["RaidRecord"]["Kaiqi"]=="ON" and PIG["RaidRecord"]["RsettingF_jiaoyijilu"]=="ON" then
		--print("注册交易事件")
		jiaoyijiluFFFF:RegisterEvent("UI_INFO_MESSAGE");--交易信息
		jiaoyijiluFFFF:RegisterEvent("TRADE_SHOW");
		jiaoyijiluFFFF:RegisterEvent("TRADE_CLOSED");
		--jiaoyijiluFFFF:RegisterEvent("TRADE_REQUEST_CANCEL");--取消交易尝试时触发。
		-- jiaoyijiluFFFF:RegisterEvent("PLAYER_TRADE_MONEY");--当玩家进行交易时被触发
		jiaoyijiluFFFF:RegisterEvent("TRADE_MONEY_CHANGED");--交易窗口的货币值更改时触发。
		jiaoyijiluFFFF:RegisterEvent("TRADE_PLAYER_ITEM_CHANGED");
		jiaoyijiluFFFF:RegisterEvent("TRADE_TARGET_ITEM_CHANGED");
		jiaoyijiluFFFF:RegisterEvent("TRADE_ACCEPT_UPDATE");--当玩家和目标接受按钮的状态更改时触发。
	else
		--print("注销掉交易事件")
		jiaoyijiluFFFF:UnregisterEvent("UI_INFO_MESSAGE");--交易信息
		jiaoyijiluFFFF:UnregisterEvent("TRADE_SHOW");
		jiaoyijiluFFFF:UnregisterEvent("TRADE_CLOSED");
		--jiaoyijiluFFFF:UnregisterEvent("TRADE_REQUEST_CANCEL");--取消交易尝试时触发。
		-- jiaoyijiluFFFF:UnregisterEvent("PLAYER_TRADE_MONEY");--当玩家进行交易时被触发
		jiaoyijiluFFFF:UnregisterEvent("TRADE_MONEY_CHANGED");--交易窗口的货币值更改时触发。
		jiaoyijiluFFFF:UnregisterEvent("TRADE_PLAYER_ITEM_CHANGED");
		jiaoyijiluFFFF:UnregisterEvent("TRADE_TARGET_ITEM_CHANGED");
		jiaoyijiluFFFF:UnregisterEvent("TRADE_ACCEPT_UPDATE");--当玩家和目标接受按钮的状态更改时触发。
	end
end
------------
local RsettingF_jiaoyijilu = CreateFrame("CheckButton", "RsettingF_jiaoyijilu_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_jiaoyijilu:SetSize(28,28);
RsettingF_jiaoyijilu:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",20,-150);
RsettingF_jiaoyijilu_UIText:SetText("记录物品交易");
RsettingF_jiaoyijilu.tooltip = "开启后,交易拾取目录内的物品将会自动填入成交价及成交人。一次交易多件商品只会记录成交人需手动输入每件商品成交价\n|cff00ff00（其他已安装本插件的玩家也会收到此次交易信息）|r";
RsettingF_jiaoyijilu:SetScript("OnClick", function ()
	if RsettingF_jiaoyijilu_UI:GetChecked() then
		PIG["RaidRecord"]["RsettingF_jiaoyijilu"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_jiaoyijilu"]="OFF";
	end
	jiaoyijiluFun()
end);
------------
local RsettingF_liupaibobao = CreateFrame("CheckButton", "RsettingF_liupaibobao_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_liupaibobao:SetSize(28,28);
RsettingF_liupaibobao:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",260,-150);
RsettingF_liupaibobao_UIText:SetText("播报流拍物品");
RsettingF_liupaibobao.tooltip = "开启后,发送拍卖明细时会播报流拍物品";
RsettingF_liupaibobao:SetScript("OnClick", function ()
	if RsettingF_liupaibobao_UI:GetChecked() then
		PIG["RaidRecord"]["RsettingF_liupaibobao"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_liupaibobao"]="OFF";
	end
end);
-----------------------
local function zhixingxiufucaizhi()
	RsettingF_UI:SetBackdrop({bgFile = "interface/characterframe/ui-party-background.blp", 
	edgeFile = "interface/glues/common/textpanel-border.blp", 
	tile = false, tileSize = 0, edgeSize = 20,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	invite_UI:SetBackdrop({bgFile = "interface/characterframe/ui-party-background.blp", 
	edgeFile = "interface/glues/common/textpanel-border.blp", 
	tile = false, tileSize = 20, edgeSize = 20,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	History_UI:SetBackdrop({bgFile = "interface/characterframe/ui-party-background.blp", 
	edgeFile = "interface/glues/common/textpanel-border.blp", 
	tile = false, tileSize = 0, edgeSize = 20,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	fenG_UI:SetBackdrop({bgFile = "interface/characterframe/ui-party-background.blp", 
	edgeFile = "interface/glues/common/textpanel-border.blp", 
	tile = false, tileSize = 0, edgeSize = 20,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
end
RsettingF.xiufucaizhi = CreateFrame("CheckButton", nil, RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF.xiufucaizhi:SetSize(28,28);
RsettingF.xiufucaizhi:SetPoint("TOPLEFT",RsettingF,"TOPLEFT",20,-250);
RsettingF.xiufucaizhi.Text:SetText("修正透明材质显示问题");
RsettingF.xiufucaizhi.tooltip = "修正因使用透明材质而产生的显示问题";
RsettingF.xiufucaizhi:SetScript("OnClick", function (self)
	if self:GetChecked() then
		zhixingxiufucaizhi()
		PIG["RaidRecord"]["RsettingF_caizhixiufu"]="ON";
	else
		PIG["RaidRecord"]["RsettingF_caizhixiufu"]="OFF";
	end
end);
----===================================================
local RsettingF_XXX = RsettingF:CreateLine()
RsettingF_XXX:SetColorTexture(1,1,1,0.3)
RsettingF_XXX:SetThickness(2);
RsettingF_XXX:SetStartPoint("TOPLEFT",5,-300)
RsettingF_XXX:SetEndPoint("TOPRIGHT",-276,-300)
---
local waiwaizidonghuifu_fuben = CreateFrame("Frame");
local RsettingF_zidonghuifuYY = CreateFrame("CheckButton", "RsettingF_zidonghuifuYY_UI", RsettingF, "ChatConfigCheckButtonTemplate");
RsettingF_zidonghuifuYY:SetSize(28,28);
RsettingF_zidonghuifuYY:SetPoint("TOPLEFT",RsettingF_XXX,"TOPLEFT",20,-10);
RsettingF_zidonghuifuYY_UIText:SetText("自动回复YY频道\124cff00FF00(你必须是队长或团长)\124r");
RsettingF_zidonghuifuYY.tooltip = "开启后,收到队伍或者团队人员咨询YY频道会自动回复预设内容";
RsettingF_zidonghuifuYY:SetScript("OnClick", function ()
	if RsettingF_zidonghuifuYY_UI:GetChecked() then
		PIG["RaidRecord"]["RsettingF_zidonghuifuYY"]="ON";
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_WHISPER") 
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_PARTY");--收到组队信息
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_PARTY_LEADER");
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_RAID");--收到团队信息
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_RAID_LEADER");
	else
		PIG["RaidRecord"]["RsettingF_zidonghuifuYY"]="OFF";
		waiwaizidonghuifu_fuben:UnregisterAllEvents();
	end
end);
--触发关键字
local zidonghuifuYYhao_biaoti = RsettingF:CreateFontString();
zidonghuifuYYhao_biaoti:SetPoint("TOPLEFT", RsettingF_zidonghuifuYY, "BOTTOMLEFT", 0,-6);
zidonghuifuYYhao_biaoti:SetFontObject(GameFontNormal);
zidonghuifuYYhao_biaoti:SetText("触发关键字(用，分隔):");
local zidonghuifuYYhao = CreateFrame("Frame", "zidonghuifuYYhao_UI", RsettingF,"BackdropTemplate");
zidonghuifuYYhao:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 16,insets = { left = 0, right = 0, top = 0, bottom = 0 }});
zidonghuifuYYhao:SetSize(310,28);
zidonghuifuYYhao:SetPoint("LEFT", zidonghuifuYYhao_biaoti, "RIGHT", 0,-0);
local zidonghuifuYYhao_E = CreateFrame('EditBox', "zidonghuifuYYhao_E_UI", zidonghuifuYYhao, InputBoxTemplate);
zidonghuifuYYhao_E:SetPoint("TOPLEFT", zidonghuifuYYhao, "TOPLEFT", 8,-6);
zidonghuifuYYhao_E:SetPoint("BOTTOMRIGHT", zidonghuifuYYhao, "BOTTOMRIGHT", -8,6);
zidonghuifuYYhao_E:SetFontObject(ChatFontNormal);
zidonghuifuYYhao_E:SetAutoFocus(false);
zidonghuifuYYhao_E:SetMaxLetters(22);
zidonghuifuYYhao_E:SetScript("OnEscapePressed", function(self) 
	self:ClearFocus() 
end);
zidonghuifuYYhao_E:SetScript("OnEnterPressed", function(self) 
	self:ClearFocus() 
end);
local function fengedianjianzi(str,delimiter)
    local dLen = string.len(delimiter)
    local newDeli = ''
    for i=1,dLen,1 do
        newDeli = newDeli .. "["..string.sub(delimiter,i,i).."]"
    end

    local locaStart,locaEnd = string.find(str,newDeli)
    local arr = {}
    local n = 1
    while locaStart ~= nil
    do
        if locaStart>0 then
            arr[n] = string.sub(str,1,locaStart-1)
            n = n + 1
        end

        str = string.sub(str,locaEnd+1,string.len(str))
        locaStart,locaEnd = string.find(str,newDeli)
    end
    if str ~= nil and str ~= "" and str ~= " " then
        arr[n] = str
    end
    return arr
end
zidonghuifuYYhao_E:SetScript("OnEditFocusLost", function(self)
	local guanjianV = self:GetText();
	local guanjianshuzu = string.gsub(guanjianV, "，", ",")
	local guanjianzilist = fengedianjianzi(guanjianshuzu, ",")
	PIG["RaidRecord"]["RsettingF_YYguanjianzi"]=guanjianzilist;
end);
--回复内容
local zidonghuifuYYhao_NR_biaoti = RsettingF:CreateFontString();
zidonghuifuYYhao_NR_biaoti:SetPoint("TOPLEFT", zidonghuifuYYhao_biaoti, "BOTTOMLEFT", 0,-18);
zidonghuifuYYhao_NR_biaoti:SetFontObject(GameFontNormal);
zidonghuifuYYhao_NR_biaoti:SetText("回复内容:");
local zidonghuifuYYhao_NR = CreateFrame("Frame", "zidonghuifuYYhao_NR_UI", RsettingF,"BackdropTemplate");
zidonghuifuYYhao_NR:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 16,insets = { left = 0, right = 0, top = 0, bottom = 0 }});
zidonghuifuYYhao_NR:SetSize(400,28);
zidonghuifuYYhao_NR:SetPoint("LEFT", zidonghuifuYYhao_NR_biaoti, "RIGHT", 0,-0);
local zidonghuifuYYhao_NR_E = CreateFrame('EditBox', "zidonghuifuYYhao_NR_E_UI", zidonghuifuYYhao_NR, InputBoxTemplate);
zidonghuifuYYhao_NR_E:SetPoint("TOPLEFT", zidonghuifuYYhao_NR, "TOPLEFT", 8,-6);
zidonghuifuYYhao_NR_E:SetPoint("BOTTOMRIGHT", zidonghuifuYYhao_NR, "BOTTOMRIGHT", -8,6);
zidonghuifuYYhao_NR_E:SetFontObject(ChatFontNormal);
zidonghuifuYYhao_NR_E:SetAutoFocus(false);
zidonghuifuYYhao_NR_E:SetMaxLetters(40);
zidonghuifuYYhao_NR_E:SetScript("OnEscapePressed", function(self) 
	self:ClearFocus() 
end);
zidonghuifuYYhao_NR_E:SetScript("OnEnterPressed", function(self) 
	self:ClearFocus() 
end);
zidonghuifuYYhao_NR_E:SetScript("OnEditFocusLost", function(self)
	PIG["RaidRecord"]["RsettingF_YYneirong"]=self:GetText();
end);
---
waiwaizidonghuifu_fuben:SetScript("OnEvent",function(self, event,arg1,_,_,_,arg5)
	if PIG["RaidRecord"]["RsettingF_zidonghuifuYY"]=="ON" then
		local isLeader = UnitIsGroupLeader("player", "LE_PARTY_CATEGORY_HOME");
		if isLeader then
			local nameziji = UnitName("player")
			if arg5~=nameziji then
				local fubenzhushou_zidonghuifuYY=string.find(arg1, "[!Pig]", 1)
				if not fubenzhushou_zidonghuifuYY then
					local YYguanjianzi=PIG["RaidRecord"]["RsettingF_YYguanjianzi"];
					for i=1,#YYguanjianzi do
						local YYhaoYES=string.find(arg1, YYguanjianzi[i], 1)
						if YYhaoYES then
							if event=="CHAT_MSG_WHISPER" then
								local IsInRaid=IsInRaid("LE_PARTY_CATEGORY_HOME");
								if IsInRaid then
									for p=1,40 do
										local name = GetUnitName("raid"..p, true)
										if name~=nil then
											if arg5==name then
												SendChatMessage("[!Pig] "..PIG["RaidRecord"]["RsettingF_YYneirong"], "WHISPER", nil, arg5);
												break
											end
										end
									end
								else
									local IsInGroup = IsInGroup("LE_PARTY_CATEGORY_HOME");
									if IsInGroup then
										for p=1,4 do
											local name = GetUnitName("party"..p, true)
											if name~=nil then
												if arg5==name then
													SendChatMessage("[!Pig] "..PIG["RaidRecord"]["RsettingF_YYneirong"], "WHISPER", nil, arg5);
													break
												end
											end
										end
									end
								end
							elseif event=="CHAT_MSG_PARTY" or event=="CHAT_MSG_PARTY_LEADER" then
								SendChatMessage("[!Pig] "..PIG["RaidRecord"]["RsettingF_YYneirong"], "PARTY", nil);
							elseif event=="CHAT_MSG_RAID" or event=="CHAT_MSG_RAID_LEADER" then
								SendChatMessage("[!Pig] "..PIG["RaidRecord"]["RsettingF_YYneirong"], "RAID_WARNING", nil);
							end
							break
						end
					end
				end
			end
		end
	end
end)
--显示============================================
Rsetting:SetScript("OnMouseDown", function ()
	Rsetting_Down:Show();
end);
Rsetting:SetScript("OnMouseUp", function ()
	Rsetting_Down:Hide();
	History_UI:Hide();
	fenG_UI:Hide();
	invite_UI:Hide();
	if RsettingF_UI:IsShown() then
		RsettingF_UI:Hide();
	else
		RsettingF_UI:Show();
		gengxinpaichu(Paichu_Scroll_UI);
	end
end);
----加载设置---------------
addonTable.RaidRecord_RsettingF = function()
	PIG["RaidRecord"]["RsettingF_YYguanjianzi"]=PIG["RaidRecord"]["RsettingF_YYguanjianzi"] or addonTable.Default["RaidRecord"]["RsettingF_YYguanjianzi"]
	PIG["RaidRecord"]["RsettingF_YYneirong"]=PIG["RaidRecord"]["RsettingF_YYneirong"] or addonTable.Default["RaidRecord"]["RsettingF_YYneirong"]
	if PIG["RaidRecord"]["RsettingF_jiaoyidaojishi"]=="ON" then
		RsettingF_jiaoyidaojishi_UI:SetChecked(true);
	end
	if PIG["RaidRecord"]["RsettingF_fubenwai"]=="ON" then
		RsettingF_fubenwai_UI:SetChecked(true);
	end
	if PIG["RaidRecord"]["RsettingF_wurenben"]=="ON" then
		RsettingF_wurenben_UI:SetChecked(true);
	end
	if PIG["RaidRecord"]["RsettingF_shoudongloot"]=="ON" then
		RsettingF_shoudongloot_UI:SetChecked(true);
	end
	if PIG["RaidRecord"]["RsettingF_jiaoyijilu"]=="ON" then
		RsettingF_jiaoyijilu_UI:SetChecked(true);
	end
	if PIG["RaidRecord"]["RsettingF_liupaibobao"]=="ON" then
		RsettingF_liupaibobao_UI:SetChecked(true);
	end
	if PIG["RaidRecord"]["RsettingF_zidonghuifuYY"]=="ON" then
		RsettingF_zidonghuifuYY_UI:SetChecked(true);
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_WHISPER") 
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_PARTY");--收到组队信息
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_PARTY_LEADER");
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_RAID");--收到团队信息
		waiwaizidonghuifu_fuben:RegisterEvent("CHAT_MSG_RAID_LEADER");
	end
	local huifuYY_guanjianzineirong="";
	for i=1,#PIG["RaidRecord"]["RsettingF_YYguanjianzi"] do
		if i~=#PIG["RaidRecord"]["RsettingF_YYguanjianzi"] then
			huifuYY_guanjianzineirong=huifuYY_guanjianzineirong..PIG["RaidRecord"]["RsettingF_YYguanjianzi"][i].."，"
		else
			huifuYY_guanjianzineirong=huifuYY_guanjianzineirong..PIG["RaidRecord"]["RsettingF_YYguanjianzi"][i]
		end
	end
	zidonghuifuYYhao_E_UI:SetText(huifuYY_guanjianzineirong)
	zidonghuifuYYhao_NR_E_UI:SetText(PIG["RaidRecord"]["RsettingF_YYneirong"])
	ITEMTimetishi();
	jiaoyijiluFun();
	PIG["RaidRecord"]["RsettingF_caizhixiufu"]=PIG["RaidRecord"]["RsettingF_caizhixiufu"] or addonTable.Default["RaidRecord"]["RsettingF_caizhixiufu"]
	if PIG["RaidRecord"]["RsettingF_caizhixiufu"]=="ON" then
		RsettingF.xiufucaizhi:SetChecked(true);
		zhixingxiufucaizhi()
	end
end
--
RsettingF.XXXXX = RsettingF:CreateLine()
RsettingF.XXXXX:SetColorTexture(1,1,1,0.3)
RsettingF.XXXXX:SetThickness(2);
RsettingF.XXXXX:SetStartPoint("BOTTOMLEFT",5,40)
RsettingF.XXXXX:SetEndPoint("BOTTOMRIGHT",-276,40)
---重置副本助手配置
local Default_Button_daibenzhushou = CreateFrame("Button","Default_Button_daibenzhushou_UI",RsettingF, "UIPanelButtonTemplate");  
Default_Button_daibenzhushou:SetSize(138,26);
Default_Button_daibenzhushou:SetPoint("BOTTOMLEFT",RsettingF,"BOTTOMLEFT",10,10);
Default_Button_daibenzhushou:SetText("重置副本助手配置");
Default_Button_daibenzhushou:SetScript("OnClick", function ()
	StaticPopup_Show ("HUIFU_DEFAULT_FUBEN");
end);
StaticPopupDialogs["HUIFU_DEFAULT_FUBEN"] = {
	text = "此操作将\124cffff0000重置\124r副本助手所有配置，需重载界面。\n确定重置?",
	button1 = "确定",
	button2 = "取消",
	OnAccept = function()
		PIG["RaidRecord"] = addonTable.Default["RaidRecord"];
		PIG["RaidRecord"]["Kaiqi"] = "ON";
		ReloadUI()
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
}